SystemOrganization addCategory: #DozEinPlan!

Object subclass: #DmAdmin
	instanceVariableNames: 'modulLeser module studienrichtungen quartalsplaene dozenten manipel standardBelegungen'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DozEinPlan'!

!DmAdmin commentStamp: '<historical>' prior: 0!
Instance Variables:
	standardBelegungen 	<Array of: Dictionary> Standardbelegungen f√ºr Lehrveranstaltungen mit Dozenten nach Semestern
	manipel 	<Manipel> 
	geschaeftsjahre 	<SortedCollection of: DozEinPlan.Geschaeftsjahr> 
	dozenten 	<SortedCollection of: DozEinPlan.Dozent> 
	quartalsplaene 	<Dictionary key: DozEinPlan.Quartal value: DozEinPlan.Quartalsplan> 
	zenturien 	<OrderedCollection of: DozEinPlan.Zenturie> 
	studienrichtungen 	<OrderedCollection of: DozEinPlan.Studienrichtung> 
	module 	<OrderedCollection of: DozEinPlan.Modul> 
	modulLeser 	<ModulLeser> !

!DmAdmin class methodsFor: 'instance creation' stamp: ' 15/1/14 15:24'!
modulLeser: a module: b studienrichtungen: c zenturien: d quartalsplaene: e dozenten: f
	
	^(self new)
		modulLeser: a;
		module: b;
		studienrichtungen: c;
		manipel: d;
		quartalsplaene: e;
		dozenten: f;
		yourself! !

!DmAdmin methodsFor: 'testing' stamp: ' 15/1/14 15:24'!
aktualisierePlanungFuer: einModul
	""
	
	self entferneLehrveranstaltungenFuer: einModul.
	self planeLehrveranstaltungenNeuFuer: einModul! !

!DmAdmin methodsFor: 'accessing' stamp: 'jb 4/3/2016 00:28'!
alleGeschaeftsjahre
	^ (self quartalsplaene collect: [ :qp | qp quartal geschaeftsjahreszahl ]) asSet asSortedCollection! !

!DmAdmin methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
alleLehrveranstaltungen
	
	| alleLehrveranstaltungen |
	alleLehrveranstaltungen := OrderedCollection new.
	self quartalsplaene
		do: [:qp | alleLehrveranstaltungen addAll: qp lehrveranstaltungen].
	^alleLehrveranstaltungen! !

!DmAdmin methodsFor: 'planung' stamp: 'JohannesBrauer 2/22/2014 00:49'!
berechneAuslastungenFuer: einGeschaeftsjahr
	
	 self dozenten
		do: [:dozent | dozent initialisiereAuslastungIn: einGeschaeftsjahr].
	self quartalsplaene
		do: [:qplan | qplan berechneAuslastungenFuer: einGeschaeftsjahr]! !

!DmAdmin methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
bewegeLehranstaltungenFuerManipel: einManipel aus: einQuartal in: anderesQuartal
	
	| quartalsplan quartalsplanNeu zuBewegendeLehrveranstaltungen |
	quartalsplan := self quartalsPlanFuer: einQuartal.
	quartalsplanNeu := self quartalsPlanFuer: anderesQuartal.
	zuBewegendeLehrveranstaltungen := quartalsplan lehrveranstaltungen
		select: [:lv | lv manipel = einManipel].
	quartalsplanNeu fuegeLehrveranstaltungenHinzu:
			zuBewegendeLehrveranstaltungen.
	quartalsplan entferneLehrveranstaltungen: zuBewegendeLehrveranstaltungen.
	zuBewegendeLehrveranstaltungen do: [:lv | lv quartal: anderesQuartal]! !

!DmAdmin methodsFor: 'testing' stamp: ' 15/1/14 15:24'!
darfManipelEntferntWerden: einManipel
	
	| alleLehrveranstaltungen |
	alleLehrveranstaltungen := OrderedCollection new.
	self quartalsplaene
		do: [:qp | alleLehrveranstaltungen addAll: qp lehrveranstaltungen].
	^(alleLehrveranstaltungen anySatisfy: [:lv | lv manipel = einManipel]) not! !

!DmAdmin methodsFor: 'testing' stamp: ' 15/1/14 15:24'!
darfModulEntferntWerden: einModul
	
	^(self alleLehrveranstaltungen anySatisfy: [:lv | lv modul == einModul])
		not! !

!DmAdmin methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
dozenten
	
	^dozenten! !

!DmAdmin methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
dozenten: anObject
	
	dozenten := anObject! !

!DmAdmin methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
dupliziereLehrveranstaltung: eineLehrveranstaltung
	
	(self quartalsplaene at: eineLehrveranstaltung quartal)
		neueLehrveranstaltung: eineLehrveranstaltung copy! !

!DmAdmin methodsFor: 'planung' stamp: 'JohannesBrauer 3/16/2014 15:07'!
dupliziereModul: einModul
	
	(self module)
		add:
				((einModul copy)
						gueltigBis: (DmQuartal jahr: 0 nr: 0);
						gueltigAb: (DmQuartal jahr: 0 nr: 0);
						yourself)! !

!DmAdmin methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
eliminiereGeschaeftsjahr: geschaeftsjahreszahl
	
	self eliminiereQuartalsplaeneFuer: geschaeftsjahreszahl! !

!DmAdmin methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
eliminiereQuartalsplaeneFuer: anInteger
	"anInteger steht fuer eine Jahreszahl"
	
	| quartal |
	quartal := DmQuartal
		jahr: anInteger - 1
		nr: 4.
	self quartalsplaene removeKey: quartal.
	quartal := DmQuartal jahr: anInteger nr: 1.
	self quartalsplaene removeKey: quartal.
	quartal := DmQuartal jahr: anInteger nr: 2.
	self quartalsplaene removeKey: quartal.
	quartal := DmQuartal jahr: anInteger nr: 3.
	self quartalsplaene removeKey: quartal! !

!DmAdmin methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
entferneDozent: einDozent
	
	self dozenten remove: einDozent! !

!DmAdmin methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
entferneLehrveranstaltung: eineLehrveranstaltung
	
	(self quartalsplaene at: eineLehrveranstaltung quartal)
		entferneLehrveranstaltung: eineLehrveranstaltung! !

!DmAdmin methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
entferneLehrveranstaltungenFuer: einModul
	
	| mussWeg |
	mussWeg := self alleLehrveranstaltungen
		select:
			[:lv | 
			lv modul == einModul
				and:
					[(lv modul
						mussModulUnterrichtetWerdenFuer: lv manipel
						inQuartal: lv quartal) not]].
	mussWeg do: [:lv | self entferneLehrveranstaltung: lv]! !

!DmAdmin methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
entferneManipel: einManipel
	
	self manipel remove: einManipel! !

!DmAdmin methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
entferneModul: einModul
	
	self module removeAllSuchThat: [:m | m == einModul]! !

!DmAdmin methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
erzeugeGeschaeftsjahr: anInteger
	"anInteger steht fuer eine Jahreszahl"
	
	self dozenten do: [:dozent | dozent initialisiereAuslastungIn: anInteger].
	self erzeugeQuartalsplaeneFuer: anInteger! !

!DmAdmin methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
erzeugeLehrveranstaltungenFuerModul: einModul inQuartal: einQuartal
	
	| modulListe quartalsplan |
	quartalsplan := self quartalsplaene at: einQuartal.
	self manipel
		do:
			[:zenturie | 
			(zenturie wirdUnterrichtetIn: einQuartal)
				ifTrue:
					[modulListe := self moduleFuer: zenturie inQuartal: einQuartal.
					quartalsplan
						erzeugeLehrveranstaltungenFuer:
							(modulListe select: [:modl | modl = einModul])
						und: zenturie
						und: einQuartal]].
	self quartalsplaene at: einQuartal put: quartalsplan! !

!DmAdmin methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
erzeugeLehrveranstaltungenFuerQuartal: einQuartal
	
	| modulListe quartalsplan |
	quartalsplan := DmQuartalsplan fuerQuartal: einQuartal.
	self manipel
		do:
			[:zenturie | 
			(zenturie wirdUnterrichtetIn: einQuartal)
				ifTrue:
					[modulListe := self moduleFuer: zenturie inQuartal: einQuartal.
					quartalsplan erzeugeLehrveranstaltungenFuer: modulListe und: zenturie
						und: einQuartal]].
	self quartalsplaene at: einQuartal put: quartalsplan! !

!DmAdmin methodsFor: 'private' stamp: 'jb 1/16/2014 19:45'!
erzeugeModulliste
	| datei |
	datei := ReadStream on: DsFileLibrary default winfobscCsv.
	self liesModuleAus: datei! !

!DmAdmin methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
erzeugeQuartalsplaeneFuer: anInteger
	"anInteger steht fuer eine Jahreszahl"
	
	| quartal |
	quartal := DmQuartal
		jahr: anInteger - 1
		nr: 4.
	self quartalsplaene
		at: quartal
		put: (DmQuartalsplan fuerQuartal: quartal).
	quartal := DmQuartal jahr: anInteger nr: 1.
	self quartalsplaene
		at: quartal
		put: (DmQuartalsplan fuerQuartal: quartal).
	quartal := DmQuartal jahr: anInteger nr: 2.
	self quartalsplaene
		at: quartal
		put: (DmQuartalsplan fuerQuartal: quartal).
	quartal := DmQuartal jahr: anInteger nr: 3.
	self quartalsplaene
		at: quartal
		put: (DmQuartalsplan fuerQuartal: quartal)! !

!DmAdmin methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
erzeugeStandardBelegungFuerQuartal: einQuartal
	
	(self quartalsplaene at: einQuartal) lehrveranstaltungen
		do:
			[:lv | 
			lv
				belegeMitStandarddozentFuerQuartal: einQuartal
				aus: self standardBelegungen]! !

!DmAdmin methodsFor: 'private' stamp: 'jb 4/5/2016 18:07'!
erzeugeStudienrichtungen
	self studienrichtungen: OrderedCollection new.
	self studienrichtungen
		add: (DmStudienrichtung mitNamen: #Wirtschaftsinformatik undAbschluss: #Bachelor);
		add: (DmStudienrichtung mitNamen: #Betriebswirtschaftslehre undAbschluss: #Bachelor);
		add: (DmStudienrichtung mitNamen: #Wirtschaftsingenieurwesen undAbschluss: #Bachelor);
		add: (DmStudienrichtung mitNamen: #Wirtschaftsinformatik undAbschluss: #Diplom);
		add: (DmStudienrichtung mitNamen: #Betriebswirtschaftslehre undAbschluss: #Diplom);
		add: (DmStudienrichtung mitNamen: #Wirtschaftsingenieurwesen undAbschluss: #Diplom);
		add: (DmStudienrichtung mitNamen: #'Angewandte-Informatik' undAbschluss: #Bachelor)! !

!DmAdmin methodsFor: 'testing' stamp: ' 15/1/14 15:24'!
existiertGeschaeftsjahrSchon: anInteger
	
	^(self quartaleImGeschaeftsjahr: anInteger) isEmpty not! !

!DmAdmin methodsFor: 'planung' stamp: 'jb 1/16/2014 08:09'!
fuegeDmDozentHinzu: aDozEinPlanDozent
	
	^self
		neuerDozent: aDozEinPlanDozent name
		vorname: aDozEinPlanDozent vorname
		insMenue: aDozEinPlanDozent insMenue! !

!DmAdmin methodsFor: 'planung' stamp: 'JohannesBrauer 3/15/2014 22:14'!
fuegeDmManipelHinzu: aDozEinPlanManipel
	
	self manipel add: aDozEinPlanManipel! !

!DmAdmin methodsFor: 'planung' stamp: 'JohannesBrauer 3/15/2014 22:17'!
fuegeDmModulHinzu: aDozEinPlanModul
	
	self module add: aDozEinPlanModul! !

!DmAdmin methodsFor: 'private' stamp: ' 15/1/14 15:24'!
fuegeModulHinzuWennNeu: einModul
	
	(self module includes: einModul) ifFalse: [self module add: einModul]! !

!DmAdmin methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
geschaeftsjahre
	
	^(self quartalsplaene collect: [:qp | qp quartal jahr]) asSet! !

!DmAdmin methodsFor: 'private' stamp: ' 15/1/14 15:24'!
initialisiereAuslastungenInExistierendenGeschaeftsjahrenFuer: einDozent
	
	| geschaeftsjahre |
	geschaeftsjahre := self geschaeftsjahre asSortedCollection.
	geschaeftsjahre removeFirst.	"weil das Geschaeftsjahr 2006/2007 2007 ist"
	geschaeftsjahre do: [:gj | einDozent initialisiereAuslastungIn: gj]! !

!DmAdmin methodsFor: 'initialize-release' stamp: 'jb 1/17/2014 08:21'!
initialize
	"self setLineEndCharacter."

	self manipel: OrderedCollection new.
	self module: OrderedCollection new.
	self dozenten: SortedCollection new.
	self quartalsplaene: Dictionary new.
	self liesDozentenAusDatei.
	DmDozent nn: (self dozenten select: [ :d | d name = 'NN' ]) first.
	DsEinsatzplanung aktuellesGeschaeftsjahr: 1.
	self erzeugeStudienrichtungen.
	self erzeugeModulliste.
	self liesManipelAusDatei! !

!DmAdmin methodsFor: 'uebergangsloesungfuerAI' stamp: 'jb 4/5/2016 17:28'!
legStudienrichtungAngInforAnFallsNichtExistiert
	self studienrichtungen
		detect: [ :sr | sr name = #'Angewandte-Informatik' ]
		ifNone: [ self studienrichtungen 
			        add: 
			            (DmStudienrichtung mitNamen: #'Angewandte-Informatik' 
			                               undAbschluss: #Bachelor) ]! !

!DmAdmin methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
lehrveranstaltungenIn: einQuartal
	
	^(self quartalsplaene at: einQuartal) lehrveranstaltungen! !

!DmAdmin methodsFor: 'planung' stamp: 'JohannesBrauer 2/18/2014 22:54'!
lehrveranstaltungenInGjahr: anInteger fuerDozent: einDozent 
	
	|qplaene lven|
	lven := OrderedCollection new.
	qplaene := self quartaleImGeschaeftsjahr: anInteger.
	qplaene do: [:q | lven addAll:  (self lehrveranstaltungenIn: q)].
	^lven select: [ :lv | lv dozent = einDozent  ]! !

!DmAdmin methodsFor: 'private' stamp: 'jb 1/16/2014 19:15'!
liesDozentenAusDatei
	
	| ds |
	ds := ReadStream on: (DsFileLibrary default dozentenCsv).					
	[[ds atEnd]
		whileFalse:
			[self dozenten
				add:
					(DmDozent
						name: (ds upTo: Character cr)
						vorname: ''
						insMenue: false)]] ensure: [ds close]! !

!DmAdmin methodsFor: 'private' stamp: 'jb 1/17/2014 08:37'!
liesManipelAusDatei
	""

	| z zs trenner name studienbeginn abschluss studienrichtung gruppen semesterZuordnung |
	trenner := $,.
	zs := ReadStream on: DsFileLibrary default manipelsemesterCsv.
	zs upTo: Character cr.	"√úberschritften skippen"
	[ 
	[ zs atEnd ]
		whileFalse: [ 
			name := zs upTo: trenner.
			gruppen := zs upTo: trenner.
			studienbeginn := zs upTo: trenner.
			studienrichtung := zs upTo: trenner.
			abschluss := zs upTo: trenner.
			semesterZuordnung := self liesSemesterZuordnungAus: zs.
			z := DmManipel
				name: name asSymbol
				gruppen: gruppen asNumber
				studienbeginn: (DmQuartal jahr: studienbeginn asNumber nr: 4)
				studienrichtung: (self studienrichtungMit: studienrichtung und: abschluss)
				semesterZuordnung: semesterZuordnung.
			self manipel add: z ] ]
		ensure: [ zs close ]! !

!DmAdmin methodsFor: 'private' stamp: ' 15/1/14 15:24'!
liesModuleAus: datei
	
	| readingBlock studienrichtungsBezeichnung abschlussBezeichnung |
	self modulLeser: (DmModulLeser oeffneDatenquelle: datei).
	readingBlock := [studienrichtungsBezeichnung := self modulLeser
		liesStudienrichtungsbezeichung.
	abschlussBezeichnung := self modulLeser liesAbschlussbezeichung.
	self
		liesModuleFuer:
			(self studienrichtungMit: studienrichtungsBezeichnung und:
					abschlussBezeichnung)].
	readingBlock ensure: [self modulLeser schliesseDatenquelle]! !

!DmAdmin methodsFor: 'private' stamp: ' 15/1/14 15:24'!
liesModuleFuer: studienrichtungsBezeichnung
	
	| modul |
	[self modulLeser datenquelleErschoepft]
		whileFalse:
			[modul := DmModul modulAus: self modulLeser.
			modul studienrichtung: studienrichtungsBezeichnung.
			self fuegeModulHinzuWennNeu: modul]! !

!DmAdmin methodsFor: 'private' stamp: 'jb 1/17/2014 08:39'!
liesSemesterZuordnungAus: datei
	""
	
	| trenner semesterZuordnung |
	trenner := $,.
	semesterZuordnung := Dictionary new.
	semesterZuordnung
		at: (DmQuartal from: (datei upTo: trenner))
		put: 1.
	semesterZuordnung
		at: (DmQuartal from: (datei upTo: trenner))
		put: 2.
	semesterZuordnung
		at: (DmQuartal from: (datei upTo: trenner))
		put: 3.
	semesterZuordnung
		at: (DmQuartal from: (datei upTo: trenner))
		put: 4.
	semesterZuordnung
		at: (DmQuartal from: (datei upTo: trenner))
		put: 5.
	semesterZuordnung
		at: (DmQuartal from: (datei upTo: trenner))
		put: 6.
	semesterZuordnung
		at: (DmQuartal from: (datei upTo: Character cr))
		put: 7.
	^semesterZuordnung! !

!DmAdmin methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
manipel
	
	^manipel! !

!DmAdmin methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
manipel: anObject
	
	manipel := anObject! !

!DmAdmin methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
menueDozenten
	
	^dozenten select: [:d | d insMenue]! !

!DmAdmin methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
modulLeser
	
	^modulLeser! !

!DmAdmin methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
modulLeser: anObject
	
	modulLeser := anObject! !

!DmAdmin methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
module
	
	^module! !

!DmAdmin methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
module: anObject
	
	module := anObject! !

!DmAdmin methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
moduleFuer: eineZenturie inQuartal: einQuartal
	
	| modulListe |
	modulListe := self module
		select:
			[:modul | modul mussModulUnterrichtetWerdenFuer: eineZenturie inQuartal: einQuartal].
	^modulListe! !

!DmAdmin methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
moduleFuerQuartal: einQuartal
	
	| modulListe |
	modulListe := OrderedCollection new.
	self manipel
		do:
			[:zenturie | 
			(zenturie wirdUnterrichtetIn: einQuartal)
				ifTrue:
					[modulListe addAll: (self moduleFuer: zenturie inQuartal: einQuartal)]].
	^modulListe! !

!DmAdmin methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
neuerDozent: aString vorname: aString2 insMenue: aBoolean
	
	| dozent |
	dozent := DmDozent name: aString vorname: aString2 insMenue: aBoolean.
	self initialisiereAuslastungenInExistierendenGeschaeftsjahrenFuer: dozent.
	self dozenten add: dozent! !

!DmAdmin methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
planeLehrveranstaltungenNeuFuer: einModul
	""
	
	self quartalsplaene
		do:
			[:qp | 
			self manipel
				do:
					[:m | 
					(einModul
						mussModulUnterrichtetWerdenFuer: m
						inQuartal: qp quartal)
						ifTrue:
							[qp
								neueLehrveranstaltung:
									(DmLehrveranstaltung
										modul: einModul
										zenturie: m
										quartal: qp quartal)]]]! !

!DmAdmin methodsFor: 'planung' stamp: 'jb 4/2/2016 23:56'!
quartaleImGeschaeftsjahr: anInteger
	"anInteger steht für eine Geschaeftsjahreszahl"
	
	^(self quartalsplaene
		select: [:quaplan | quaplan liegtImGeschaeftsjahr: anInteger])
		collect: [:quaplan | quaplan quartal]! !

!DmAdmin methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
quartalsPlanFuer: einQuartal
	
	^self quartalsplaene detect: [:qp | qp quartal = einQuartal]! !

!DmAdmin methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
quartalsplaene
	
	^quartalsplaene! !

!DmAdmin methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
quartalsplaene: anObject
	
	quartalsplaene := anObject! !

!DmAdmin methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
standardBelegungen
	
	^standardBelegungen! !

!DmAdmin methodsFor: 'private' stamp: ' 15/1/14 15:24'!
studienrichtungMit: studienrichtungsBezeichnung und: abschlussBezeichnung
	
	^self studienrichtungen
		detect:
			[:sr | 
			sr name = studienrichtungsBezeichnung asSymbol
				& (sr abschluss = abschlussBezeichnung asSymbol)]! !

!DmAdmin methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
studienrichtungen
	
	^studienrichtungen! !

!DmAdmin methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
studienrichtungen: anObject
	
	studienrichtungen := anObject! !

Object subclass: #DmDozent
	instanceVariableNames: 'name vorname auslastungen insMenue sollStunden'
	classVariableNames: 'NN'
	poolDictionaries: ''
	category: 'DozEinPlan'!

!DmDozent commentStamp: '<historical>' prior: 0!
Instance Variables:
	sollStunden 	<Integer> Jahreslehrdeputat
	fbMitglied 	<Boolean> 
	auslastungen 	<Dictionary of: Core.Integer> 
	name 	<String> 
	vorname 	<Core.String> !

!DmDozent class methodsFor: 'instance creation' stamp: ' 15/1/14 15:24'!
name: aString vorname: anotherString insMenue: aBoolean
	
	^(self new)
		name: aString;
		vorname: anotherString;
		insMenue: aBoolean;
		auslastungen: Dictionary new;
		sollStunden: 0;
		yourself! !

!DmDozent class methodsFor: 'instance creation' stamp: ' 15/1/14 15:24'!
name: aString vorname: anotherString insMenue: aBoolean sollStunden: anInteger auslastungen: aDictionary
	
	^(self new)
		name: aString;
		vorname: anotherString;
		insMenue: aBoolean;
		auslastungen: aDictionary;
		sollStunden: anInteger;
		yourself! !

!DmDozent class methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
nn
	
	^NN! !

!DmDozent class methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
nn: einDozent
	
	NN := einDozent! !

!DmDozent methodsFor: 'comparing' stamp: ' 15/1/14 15:24'!
<= einDozent
	
	^self name < einDozent name
		| (self name = einDozent name & (self vorname <= einDozent vorname))! !

!DmDozent methodsFor: 'comparing' stamp: ' 15/1/14 15:24'!
= einDozent
	
	einDozent isNil ifTrue: [^true].	"Trick wg. Problems in der UI beim L√∂schen von Dozenten oder LVen, wenn Fokus in Dozent"
	^self name = einDozent name & (self vorname = einDozent vorname)! !

!DmDozent methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
auslastungen
	
	^auslastungen! !

!DmDozent methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
auslastungen: anObject
	
	auslastungen := anObject! !

!DmDozent methodsFor: 'comparing' stamp: ' 15/1/14 15:24'!
hash
	
	^self name hash bitXor: self vorname hash! !

!DmDozent methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
initialisiereAuslastungIn: anInteger
	"anInteger steht fuer eine Jahreszahl"
	
	self auslastungen
		at: anInteger
		put: (Array with: 0 with: 0 with: 0 with: 0)! !

!DmDozent methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
insMenue
	
	^insMenue! !

!DmDozent methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
insMenue: anObject
	
	insMenue := anObject! !

!DmDozent methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
insMenueJaNein
	
	^insMenue
		ifTrue: ['ja']
		ifFalse: ['nein']! !

!DmDozent methodsFor: 'testing' stamp: ' 15/1/14 15:24'!
istNeu: aDozEinPlanDozent
	
	^self name ~= aDozEinPlanDozent name! !

!DmDozent methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
name
	
	^name! !

!DmDozent methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
name: anObject
	
	name := anObject! !

!DmDozent methodsFor: 'copying' stamp: ' 15/1/14 15:24'!
postCopy
	
	super postCopy.
	self
		vorname: self vorname copy;
		insMenue: self insMenue copy;
		sollStunden: self sollStunden copy;
		auslastungen: self auslastungen copy! !

!DmDozent methodsFor: 'printing' stamp: ' 15/1/14 15:24'!
printOn: aStream
	
	aStream nextPutAll: self name! !

!DmDozent methodsFor: 'binary storage' stamp: ' 15/1/14 15:24'!
representBinaryOn: binWriter
	
	^MessageSend
		receiver: self class
		selector: #name:vorname:insMenue:sollStunden:auslastungen:
		arguments:
			((OrderedCollection new)
				add: self name;
				add: self vorname;
				add: self insMenue;
				add: self sollStunden;
				add: self auslastungen;
				yourself) asArray! !

!DmDozent methodsFor: 'planung' stamp: 'JohannesBrauer 2/8/2014 20:38'!
schreibeStunden: anInteger gutFuer: einQuartal
	
	| auslastung index |
	auslastung := self auslastungen at: einQuartal geschaeftsjahreszahl.
	index := einQuartal nr = 4
		ifTrue: [1]
		ifFalse: [einQuartal nr + 1].
	auslastung
		at: index
		put: ((auslastung at: index) + anInteger round: 1)! !

!DmDozent methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
sollStunden
	
	^sollStunden! !

!DmDozent methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
sollStunden: anObject
	
	sollStunden := anObject! !

!DmDozent methodsFor: 'planung' stamp: 'jb 1/21/2014 22:40'!
stundenInQ1
	
	^(self auslastungen at: DsEinsatzplanung aktuellesGeschaeftsjahr) at: 2! !

!DmDozent methodsFor: 'planung' stamp: 'jb 1/21/2014 22:40'!
stundenInQ2
	
	^(self auslastungen at: DsEinsatzplanung aktuellesGeschaeftsjahr) at: 3! !

!DmDozent methodsFor: 'planung' stamp: 'jb 1/21/2014 22:40'!
stundenInQ3
	
	^(self auslastungen at: DsEinsatzplanung aktuellesGeschaeftsjahr) at: 4! !

!DmDozent methodsFor: 'planung' stamp: 'jb 1/21/2014 22:38'!
stundenInQ4
	
	^(self auslastungen at: DsEinsatzplanung aktuellesGeschaeftsjahr) first! !

!DmDozent methodsFor: 'planung' stamp: 'JohannesBrauer 2/8/2014 20:35'!
summe
	
	^((self auslastungen at: DsEinsatzplanung aktuellesGeschaeftsjahr)
		inject: 0
		into: [:sum :q | sum + q]) round: 1! !

!DmDozent methodsFor: 'copying' stamp: 'jb 1/26/2014 19:18'!
ueberNimmDatenVon: aDozEinPlanDozent
	
	self
		vorname: aDozEinPlanDozent vorname;
		insMenue: aDozEinPlanDozent insMenue;
		sollStunden: aDozEinPlanDozent sollStunden asNumber! !

!DmDozent methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
vorname
	
	^vorname! !

!DmDozent methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
vorname: anObject
	
	vorname := anObject! !

Object subclass: #DmLehrveranstaltung
	instanceVariableNames: 'modul quartal dozent wiederholungsFaktor manipel anzahlGruppen'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DozEinPlan'!

!DmLehrveranstaltung commentStamp: '<historical>' prior: 0!
Instance Variables:
	anzahlGruppen 	<Integer> 
	manipel 	<Manipel> 
	wiederholungsFaktor 	<Fraction> 
	dozent 	<DozEinPlan.Dozent> 
	zenturie 	<Zenturie> 
	quartal 	<DozEinPlan.Quartal> 
	modul 	<DozEinPlan.Modul> !

!DmLehrveranstaltung class methodsFor: 'instance creation' stamp: ' 15/1/14 15:24'!
modul: einModul zenturie: einManipel quartal: einQuartal
	
	^self new initialisiereModul: einModul manipel: einManipel quartal:
			einQuartal! !

!DmLehrveranstaltung methodsFor: 'sixx' stamp: 'JohannesBrauer 2/1/2014 19:50'!
<= aLv
	^self modul modulNummer <= aLv modul modulNummer! !

!DmLehrveranstaltung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
anzahlGruppen
	
	^anzahlGruppen! !

!DmLehrveranstaltung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
anzahlGruppen: anObject
	
	anzahlGruppen := anObject asNumber! !

!DmLehrveranstaltung methodsFor: 'planung' stamp: 'JohannesBrauer 3/16/2014 15:57'!
belegeMitStandarddozentFuerQuartal: einQuartal aus: standardBelegungen
	| semester |
	self dozent name = 'NN'
		ifFalse: [ ^ self ].
	semester := self manipel semesterInQuartal: einQuartal.
	((standardBelegungen at: semester) includesKey: self modul modulName)
		ifTrue: [ self dozent: ((standardBelegungen at: semester) at: self modul modulName) ]! !

!DmLehrveranstaltung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
dozent
	
	^dozent! !

!DmLehrveranstaltung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
dozent: einDozent
	
	dozent := einDozent! !

!DmLehrveranstaltung methodsFor: 'planung' stamp: 'JohannesBrauer 3/16/2014 16:09'!
exportTo: aStream
	| tabAsString |
	tabAsString := String with: Character tab.
	aStream
		nextPutAll: self modul modulNummer;
		nextPutAll: tabAsString;
		nextPutAll: self modul modulName;
		nextPutAll: tabAsString;
		nextPutAll: self manipel name;
		nextPutAll: tabAsString;
		nextPutAll: self semester printString;
		nextPutAll: tabAsString;
		nextPutAll: self semesterWochenstunden printString;
		nextPutAll: tabAsString;
		nextPutAll: self wiederholungsFaktor printString;
		nextPutAll: tabAsString;
		nextPutAll: self anzahlGruppen printString;
		nextPutAll: tabAsString;
		nextPutAll: self dozent name;
		nextPutAll: tabAsString;
		nextPutAll: self quartal printString;
		nextPut: Character cr! !

!DmLehrveranstaltung methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
geschaeftsjahreszahl
	
	^self quartal nr = 4
		ifTrue: [self quartal jahr + 1]
		ifFalse: [self quartal jahr]! !

!DmLehrveranstaltung methodsFor: 'initialize-release' stamp: ' 15/1/14 15:24'!
initialisiereModul: einModul manipel: einManipel quartal: einQuartal
	
	self
		modul: einModul;
		manipel: einManipel;
		quartal: einQuartal;
		wiederholungsFaktor: 1 / 1;
		dozent: DmDozent nn;
		anzahlGruppen: einManipel anzahlGruppen! !

!DmLehrveranstaltung methodsFor: 'planung' stamp: 'JohannesBrauer 2/19/2014 18:54'!
lvStunden
	^ self semesterWochenstunden * 10 * self wiederholungsFaktor * self anzahlGruppen! !

!DmLehrveranstaltung methodsFor: 'displaying' stamp: 'JohannesBrauer 2/19/2014 19:21'!
lvStundenGerundet

	^self lvStunden round: 1 ! !

!DmLehrveranstaltung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
manipel
	
	^manipel! !

!DmLehrveranstaltung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
manipel: anObject
	
	manipel := anObject! !

!DmLehrveranstaltung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
modul
	
	^modul! !

!DmLehrveranstaltung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
modul: anObject
	
	modul := anObject! !

!DmLehrveranstaltung methodsFor: 'printing' stamp: 'JohannesBrauer 3/16/2014 16:10'!
printOn: aStream
	aStream
		nextPutAll: 'LV: ';
		nextPutAll: self modul printString;
		nextPutAll: 'für ';
		nextPutAll: self manipel printString! !

!DmLehrveranstaltung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
quartal
	
	^quartal! !

!DmLehrveranstaltung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
quartal: anObject
	
	quartal := anObject! !

!DmLehrveranstaltung methodsFor: 'planung' stamp: 'JohannesBrauer 2/19/2014 18:54'!
schreibeStundenAufDozenten
	self dozent schreibeStunden: self lvStunden gutFuer: self quartal! !

!DmLehrveranstaltung methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester
	
	^self manipel semesterInQuartal: self quartal! !

!DmLehrveranstaltung methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semesterWochenstunden
	
	^self modul wochenStundenInSemester: self semester! !

!DmLehrveranstaltung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
wiederholungsFaktor
	
	^wiederholungsFaktor! !

!DmLehrveranstaltung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
wiederholungsFaktor: anObject
	
	wiederholungsFaktor := anObject asNumber! !

!DmLehrveranstaltung methodsFor: 'displaying' stamp: 'JohannesBrauer 2/19/2014 19:18'!
wiederholungsFaktorGerundet
	
	^wiederholungsFaktor round: 2! !

Object subclass: #DmManipel
	instanceVariableNames: 'studienrichtung name studienbeginn anzahlGruppen jahrSemesterZuordnung'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DozEinPlan'!

!DmManipel commentStamp: '<historical>' prior: 0!
Instance Variables:
	anzahlGruppen 	<Integer> 
	studienbeginn 	<Quartal> 
	name 	<String> 
	studienrichtung 	<Studienrichtung> !

!DmManipel class methodsFor: 'instance creation' stamp: ' 15/1/14 15:24'!
name: aSymbol gruppen: anInteger studienbeginn: einQuartal studienrichtung: eineStudienrichtung semesterZuordnung: aDictionary
	
	^(self new)
		name: aSymbol;
		anzahlGruppen: anInteger;
		studienbeginn: einQuartal;
		studienrichtung: eineStudienrichtung;
		jahrSemesterZuordnung: aDictionary;
		yourself! !

!DmManipel methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
anzahlGruppen
	
	^anzahlGruppen! !

!DmManipel methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
anzahlGruppen: anObject
	
	anzahlGruppen := anObject asNumber! !

!DmManipel methodsFor: 'testing' stamp: ' 15/1/14 15:24'!
istNeu: aDozEinPlanManipel
	
	^self name ~= aDozEinPlanManipel name! !

!DmManipel methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
jahrSemesterZuordnung
	
	^jahrSemesterZuordnung! !

!DmManipel methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
jahrSemesterZuordnung: anObject
	
	jahrSemesterZuordnung := anObject! !

!DmManipel methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
name
	
	^name! !

!DmManipel methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
name: anObject
	
	name := anObject asSymbol! !

!DmManipel methodsFor: 'copying' stamp: 'JohannesBrauer 3/16/2014 15:12'!
postCopy
	
	super postCopy.
	self
		studienrichtung: self studienrichtung;
		studienbeginn: self studienbeginn copy;
		anzahlGruppen: self anzahlGruppen;
		jahrSemesterZuordnung: self jahrSemesterZuordnung copy! !

!DmManipel methodsFor: 'printing' stamp: ' 15/1/14 15:24'!
printOn: aStream
	
	aStream nextPutAll: self name! !

!DmManipel methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester1
	
	^self semester: 1! !

!DmManipel methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester1: aQuartalString
	
	self semester: 1 imQuartal: aQuartalString! !

!DmManipel methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester2
	
	^self semester: 2! !

!DmManipel methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester2: aQuartalString
	
	self semester: 2 imQuartal: aQuartalString! !

!DmManipel methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester3
	
	^self semester: 3! !

!DmManipel methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester3: aQuartalString
	
	self semester: 3 imQuartal: aQuartalString! !

!DmManipel methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester4
	
	^self semester: 4! !

!DmManipel methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester4: aQuartalString
	
	self semester: 4 imQuartal: aQuartalString! !

!DmManipel methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester5
	
	^self semester: 5! !

!DmManipel methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester5: aQuartalString
	
	self semester: 5 imQuartal: aQuartalString! !

!DmManipel methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester6
	
	^self semester: 6! !

!DmManipel methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester6: aQuartalString
	
	self semester: 6 imQuartal: aQuartalString! !

!DmManipel methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester7
	
	^self semester: 7! !

!DmManipel methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester7: aQuartalString
	
	self semester: 7 imQuartal: aQuartalString! !

!DmManipel methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester: anInteger
	
	^(self semesterNachQuartal: anInteger) printString! !

!DmManipel methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester: anInteger imQuartal: aQuartalString
	
	| q |
	q := DmQuartal fromString: aQuartalString.
	self jahrSemesterZuordnung
		removeKey: (self jahrSemesterZuordnung keyAtValue: anInteger).
	self jahrSemesterZuordnung
		at:
			(DmQuartal
				jahr: q jahr - self studienbeginn jahr
				nr: q nr)
		put: anInteger! !

!DmManipel methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semesterInQuartal: einQuartal
	
	^self jahrSemesterZuordnung
		at: einQuartal - self studienbeginn
		ifAbsent: 0! !

!DmManipel methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semesterNachQuartal: anInteger
	
	| quartal |
	quartal := self jahrSemesterZuordnung keyAtValue: anInteger.
	^DmQuartal
		jahr: quartal jahr + self studienbeginn jahr
		nr: quartal nr! !

!DmManipel methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
studienbeginn
	
	^studienbeginn! !

!DmManipel methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
studienbeginn: anObject
	
	studienbeginn := anObject! !

!DmManipel methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
studienbeginnAsString
	
	^studienbeginn printString! !

!DmManipel methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
studienbeginnAsString: aString
	
	studienbeginn := DmQuartal fromString: aString! !

!DmManipel methodsFor: 'accessing-seaside' stamp: ' 15/1/14 15:24'!
studienbeginnSea
	
	^self studienbeginn! !

!DmManipel methodsFor: 'accessing-seaside' stamp: ' 15/1/14 15:24'!
studienbeginnSea: aByteString
	
	self
		studienbeginn:
			(DmQuartal
				jahr: (aByteString copyFrom: 1 to: 4) asNumber
				nr: 4)! !

!DmManipel methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
studienrichtung
	
	^studienrichtung! !

!DmManipel methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
studienrichtung: anObject
	
	studienrichtung := anObject! !

!DmManipel methodsFor: 'copying' stamp: ' 15/1/14 15:24'!
ueberNimmDatenVon: aDozEinPlanManipel
	
	self
		studienrichtung: aDozEinPlanManipel studienrichtung;
		studienbeginn: aDozEinPlanManipel studienbeginn;
		anzahlGruppen: aDozEinPlanManipel anzahlGruppen.
	self jahrSemesterZuordnung: aDozEinPlanManipel jahrSemesterZuordnung! !

!DmManipel methodsFor: 'testing' stamp: ' 15/1/14 15:24'!
wirdUnterrichtetIn: einQuartal
	
	^self jahrSemesterZuordnung includesKey: einQuartal - self studienbeginn! !

Object subclass: #DmModul
	instanceVariableNames: 'modulNummer modulName semesterWochenstunden studienrichtung gueltigBis gueltigAb'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DozEinPlan'!

!DmModul commentStamp: '<historical>' prior: 0!
Instance Variables:
	studienrichtung 	<DozEinPlan.Studienrichtung> Studienrichtung des Moduls
	anzahlSemester 	<Integer> Anzahl der Semester des Moduls
	semesterWochenstunden 	<Dictionary> Zuordnung Semester - Wochenstunden des Moduls
	modulName 	<String> Modulname lt. Studienplan
	modulNummer 	<Core.Symbol> Modulnummer lt. Studienplan
!

!DmModul class methodsFor: 'instance creation' stamp: ' 15/1/14 15:24'!
modulAus: einModulLeser
	
	^self
		nummer: einModulLeser extrahiereModulnummer asSymbol
		name: einModulLeser extrahiereModulname
		semesterWochenstunden: einModulLeser extrahiereSemesterWochenstunden! !

!DmModul class methodsFor: 'instance creation' stamp: ' 15/1/14 15:24'!
nummer: aSymbol name: aString semesterWochenstunden: aDictionary
	"erzeugt ein Modul mit modulNummer aSymbol und modulName aString und Semester-Wochenstunden-Zuordnung aDiotionary"
	
	^self new nummer: aSymbol name: aString semesterWochenstunden: aDictionary! !

!DmModul methodsFor: 'comparing' stamp: ' 15/1/14 15:24'!
= aModul
	
	^self modulNummer = aModul modulNummer! !

!DmModul methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
ab
	
	^self gueltigAb! !

!DmModul methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
ab: aString
	
	self gueltigAb: (DmQuartal fromString: aString)! !

!DmModul methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
bis
	
	^self gueltigBis! !

!DmModul methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
bis: aString
	
	self gueltigBis: (DmQuartal fromString: aString)! !

!DmModul methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
gueltigAb
	
	^gueltigAb! !

!DmModul methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
gueltigAb: einQuartal
	
	gueltigAb := einQuartal! !

!DmModul methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
gueltigBis
	
	^gueltigBis! !

!DmModul methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
gueltigBis: anObject
	
	gueltigBis := anObject! !

!DmModul methodsFor: 'testing' stamp: ' 15/1/14 15:24'!
gueltigkeitGeaendert: aDozEinPlanModul
	
	^self gueltigAb ~= aDozEinPlanModul gueltigAb
		or: [self gueltigBis ~= aDozEinPlanModul gueltigBis]! !

!DmModul methodsFor: 'comparing' stamp: ' 15/1/14 15:24'!
hash
	
	^self modulNummer hash! !

!DmModul methodsFor: 'testing' stamp: ' 15/1/14 15:24'!
istNeu: aDozEinPlanModul
	
	^self modulNummer ~= aDozEinPlanModul modulNummer! !

!DmModul methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
modulName
	
	^modulName! !

!DmModul methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
modulName: anObject
	
	modulName := anObject! !

!DmModul methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
modulNummer
	
	^modulNummer! !

!DmModul methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
modulNummer: anObject
	
	modulNummer := anObject asSymbol! !

!DmModul methodsFor: 'testing' stamp: 'JohannesBrauer 3/16/2014 15:54'!
mussModulUnterrichtetWerdenFuer: eineZenturie inQuartal: einQuartal
	| semester |
	^ self studienrichtung = eineZenturie studienrichtung
		and: [ 
			semester := eineZenturie semesterInQuartal: einQuartal.
			(self semesterWochenstunden includesKey: semester)
				and: [ 
					(self semesterWochenstunden at: semester) > 0
						and: [ eineZenturie studienbeginn between: self gueltigAb and: self gueltigBis ] ] ]! !

!DmModul methodsFor: 'initialize-release' stamp: ' 15/1/14 15:24'!
nummer: aSymbol name: aString semesterWochenstunden: aDictionary
	"initialisiert den Empf√§nger (ein Modul) mit modulNummer aSymbol und modulName aString und Semester-Wochenstunden-Zuordnung aDiotionary"
	
	^self
		modulNummer: aSymbol;
		modulName: aString;
		semesterWochenstunden: aDictionary;
		gueltigAb: (DmQuartal jahr: 2000 nr: 4);
		gueltigBis: (DmQuartal jahr: 2999 nr: 4);
		yourself! !

!DmModul methodsFor: 'copying' stamp: ' 15/1/14 15:24'!
postCopy
	
	super postCopy.
	semesterWochenstunden := semesterWochenstunden copy.
	gueltigBis := gueltigBis copy.
	gueltigAb := gueltigAb copy! !

!DmModul methodsFor: 'printing' stamp: 'JohannesBrauer 3/16/2014 16:10'!
printOn: aStream
	aStream
		nextPutAll: self modulNummer;
		nextPutAll: ': ';
		nextPutAll: self modulName! !

!DmModul methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester1
	
	^self wochenStundenInSemester: 1! !

!DmModul methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester1: aNumber
	
	^self
		wochenStundenInSemester: 1
		put: aNumber asNumber! !

!DmModul methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester2
	
	^self wochenStundenInSemester: 2! !

!DmModul methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester2: aNumber
	
	^self
		wochenStundenInSemester: 2
		put: aNumber asNumber! !

!DmModul methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester3
	
	^self wochenStundenInSemester: 3! !

!DmModul methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester3: aNumber
	
	^self
		wochenStundenInSemester: 3
		put: aNumber asNumber! !

!DmModul methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester4
	
	^self wochenStundenInSemester: 4! !

!DmModul methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester4: aNumber
	
	^self
		wochenStundenInSemester: 4
		put: aNumber asNumber! !

!DmModul methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester5
	
	^self wochenStundenInSemester: 5! !

!DmModul methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester5: aNumber
	
	^self
		wochenStundenInSemester: 5
		put: aNumber asNumber! !

!DmModul methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester6
	
	^self wochenStundenInSemester: 6! !

!DmModul methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester6: aNumber
	
	^self
		wochenStundenInSemester: 6
		put: aNumber asNumber! !

!DmModul methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester7
	
	^self wochenStundenInSemester: 7! !

!DmModul methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
semester7: aNumber
	
	^self
		wochenStundenInSemester: 7
		put: aNumber asNumber! !

!DmModul methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
semesterWochenstunden
	
	^semesterWochenstunden! !

!DmModul methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
semesterWochenstunden: anObject
	
	semesterWochenstunden := anObject! !

!DmModul methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
studienrichtung
	
	^studienrichtung! !

!DmModul methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
studienrichtung: anObject
	
	studienrichtung := anObject! !

!DmModul methodsFor: 'copying' stamp: ' 15/1/14 15:24'!
ueberNimmDatenVon: aDozEinPlanModul
	
	self
		modulName: aDozEinPlanModul modulName;
		studienrichtung: aDozEinPlanModul studienrichtung;
		semesterWochenstunden: aDozEinPlanModul semesterWochenstunden;
		gueltigBis: aDozEinPlanModul gueltigBis;
		gueltigAb: aDozEinPlanModul gueltigAb! !

!DmModul methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
wochenStundenInSemester: aNumber
	
	^self semesterWochenstunden
		at: aNumber
		ifAbsent: [0]! !

!DmModul methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
wochenStundenInSemester: aNumber put: wochenstunden
	
	^self semesterWochenstunden at: aNumber put: wochenstunden! !

Object subclass: #DmModulLeser
	instanceVariableNames: 'modulStream trenner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DozEinPlan'!

!DmModulLeser commentStamp: '<historical>' prior: 0!
Instance Variables:
	trenner 	<Character> 
	modulStream 	<ExternalReadStream> !

!DmModulLeser class methodsFor: 'instance creation' stamp: ' 15/1/14 15:24'!
oeffneDatenquelle: einDateiname
	
	^self new inititalize: einDateiname! !

!DmModulLeser methodsFor: 'testing' stamp: ' 15/1/14 15:24'!
datenquelleErschoepft
	
	^self modulStream atEnd! !

!DmModulLeser methodsFor: 'reading' stamp: ' 15/1/14 15:24'!
extrahiereModulname
	
	^self modulStream upTo: self trenner! !

!DmModulLeser methodsFor: 'reading' stamp: ' 15/1/14 15:24'!
extrahiereModulnummer
	
	^self modulStream upTo: self trenner! !

!DmModulLeser methodsFor: 'reading' stamp: 'jb 1/16/2014 21:59'!
extrahiereSemesterWochenstunden
	
	| wochenStunden semesterWochenstunden |
	semesterWochenstunden := Dictionary new.
	1
		to: 7
		do:
			[:semester | 
			wochenStunden := semester < 7
				ifTrue: [self modulStream upTo: trenner]
				ifFalse: [self modulStream upTo: Character cr].
			wochenStunden = ''
				ifFalse:
					[semesterWochenstunden
						at: semester
						put: wochenStunden trimBoth asNumber]].
	^semesterWochenstunden! !

!DmModulLeser methodsFor: 'initialize-release' stamp: 'jb 1/16/2014 19:45'!
inititalize: einDateiname
	
	self modulStream: einDateiname.
	self trenner: $,! !

!DmModulLeser methodsFor: 'reading' stamp: 'jb 1/16/2014 19:48'!
liesAbschlussbezeichung
	
	^self modulStream upTo: Character cr! !

!DmModulLeser methodsFor: 'reading' stamp: ' 15/1/14 15:24'!
liesStudienrichtungsbezeichung
	
	^self modulStream upTo: self trenner! !

!DmModulLeser methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
modulStream
	
	^modulStream! !

!DmModulLeser methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
modulStream: anObject
	
	modulStream := anObject! !

!DmModulLeser methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
schliesseDatenquelle
	
	self modulStream close! !

!DmModulLeser methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
trenner
	
	^trenner! !

!DmModulLeser methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
trenner: anObject
	
	trenner := anObject! !

Object subclass: #DmQuartalsplan
	instanceVariableNames: 'quartal lehrveranstaltungen'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DozEinPlan'!

!DmQuartalsplan commentStamp: '<historical>' prior: 0!
Instance Variables:
	lehrveranstaltungen 	<OrderedCollection of: DozEinPlan.Lehrveranstaltung> 
	quartal 	<DozEinPlan.Quartal> 
!

!DmQuartalsplan class methodsFor: 'instance creation' stamp: ' 15/1/14 15:24'!
fuerQuartal: einQuartal
	
	^self new initialize: einQuartal! !

!DmQuartalsplan class methodsFor: 'instance creation' stamp: ' 15/1/14 15:24'!
quartal: einQuartal lehrveranstaltungen: aSortedCollection
	
	^(self new)
		quartal: einQuartal;
		lehrveranstaltungen: aSortedCollection;
		yourself! !

!DmQuartalsplan methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
berechneAuslastungenFuer: anInteger
	"anInteger sthet fuer eine Geschaetsjahreszahl"
	
	(self liegtImGeschaeftsjahr: anInteger)
		ifTrue:
			[self lehrveranstaltungen do: [:lv | lv schreibeStundenAufDozenten]]! !

!DmQuartalsplan methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
entferneLehrveranstaltung: eineLehrveranstaltung
	
	self lehrveranstaltungen remove: eineLehrveranstaltung! !

!DmQuartalsplan methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
entferneLehrveranstaltungen: eineCollection
	
	self lehrveranstaltungen removeAll: eineCollection! !

!DmQuartalsplan methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
erzeugeLehrveranstaltungenFuer: modulListe und: eineZenturie und: einQuartal
	
	self lehrveranstaltungen
		addAll:
			(modulListe
				collect:
					[:modul | DmLehrveranstaltung modul: modul zenturie: eineZenturie quartal: einQuartal])! !

!DmQuartalsplan methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
fuegeLehrveranstaltungenHinzu: eineCollection
	
	self lehrveranstaltungen addAll: eineCollection! !

!DmQuartalsplan methodsFor: 'initialize-release' stamp: ' 15/1/14 15:24'!
initialize: einQuartal
	
	self
		lehrveranstaltungen:
			(SortedCollection
				sortBlock: [:x :y | x modul modulNummer <= y modul modulNummer]).
	self quartal: einQuartal! !

!DmQuartalsplan methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
lehrveranstaltungen
	
	^lehrveranstaltungen! !

!DmQuartalsplan methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
lehrveranstaltungen: anObject
	
	lehrveranstaltungen := anObject! !

!DmQuartalsplan methodsFor: 'testing' stamp: ' 15/1/14 15:24'!
liegtImGeschaeftsjahr: anInteger
	"prueft, ob das Quartal des Empfaengers im Geschaeftsjahr anInteger liegt"
	
	^self quartal jahr = (anInteger - 1) & (self quartal nr = 4)
		| (self quartal jahr = anInteger & (self quartal nr between: 1 and: 3))! !

!DmQuartalsplan methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
neueLehrveranstaltung: eineLehrveranstaltung
	
	self lehrveranstaltungen add: eineLehrveranstaltung! !

!DmQuartalsplan methodsFor: 'printing' stamp: 'JohannesBrauer 3/16/2014 16:15'!
printOn: aStream
	aStream
		nextPutAll: 'Quartalsplan: ';
		nextPutAll: self quartal printString! !

!DmQuartalsplan methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
quartal
	
	^quartal! !

!DmQuartalsplan methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
quartal: anObject
	
	quartal := anObject! !

Object subclass: #DmSixxFuelImport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DozEinPlan'!

!DmSixxFuelImport class methodsFor: 'conversion' stamp: 'jb 8/11/2017 22:38'!
alleSixxDateienNachDatensicherung
	"self alleSixxDateienNachDatensicherung"

	| disk dir sixxDir |
	disk := FileSystem disk.
	dir := disk workingDirectory / 'datensicherung'.
	dir exists
		ifTrue: [ dir deleteAll ].
	dir createDirectory.
	sixxDir := disk workingDirectory / 'datensixx'.
	(sixxDir allChildren select: [ :each | each basename endsWith: 'six' ])
		do: [ :d | d copyTo: dir / (d basename copyReplaceTokens: 'six' with: 'db').]! !

!DmSixxFuelImport class methodsFor: 'conversion' stamp: 'jb 8/11/2017 14:33'!
alleSixxDateienNachFuelKonvertieren
	"self alleSixxDateienNachFuelKonvertieren"

	| disk dir sixxDir stream objects |
	disk := FileSystem disk.
	dir := disk workingDirectory / 'datensicherung'.
	dir exists
		ifTrue: [ dir deleteAll ].
	dir createDirectory.
	sixxDir := disk workingDirectory / 'datensixx'.
	(sixxDir allChildren select: [ :each | each basename endsWith: 'six' ])
		do: [ :d | 
			"srs := SixxReadStream readOnlyFileNamed: 'obj.sixx'."
			stream := d readStream.
			stream := SixxReadStream on: stream.
			objects := stream contents.
			stream close.
			"stream := (dir / (d basename copyReplaceTokens: 'six' with: 'db')) writeStream."
			FLSerializer
				serialize: objects
				toFileNamed: 'ttt.db'  ]! !

Object subclass: #DmStudienrichtung
	instanceVariableNames: 'name abschluss'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DozEinPlan'!

!DmStudienrichtung commentStamp: '<historical>' prior: 0!
Instance Variables:
	jahrSemesterZuordnung 	<Dictionary> 
	abschluss 	<Symbol> 
	name 	<Symbol> Bezeichnung der Studienrichtung!

!DmStudienrichtung class methodsFor: 'instance creation' stamp: ' 15/1/14 15:24'!
mitNamen: aSymbol undAbschluss: anotherSymbol
	
	^self new initialisiereMitNamen: aSymbol undAbschluss: anotherSymbol! !

!DmStudienrichtung methodsFor: 'comparing' stamp: ' 15/1/14 15:24'!
<= eineStudienrichtung
	
	^self name <= eineStudienrichtung name! !

!DmStudienrichtung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
abschluss
	
	^abschluss! !

!DmStudienrichtung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
abschluss: anObject
	
	abschluss := anObject! !

!DmStudienrichtung methodsFor: 'initialize-release' stamp: ' 15/1/14 15:24'!
initialisiereMitNamen: aSymbol undAbschluss: anotherSymbol
	
	self
		name: aSymbol;
		abschluss: anotherSymbol! !

!DmStudienrichtung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
name
	
	^name! !

!DmStudienrichtung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
name: anObject
	
	name := anObject! !

!DmStudienrichtung methodsFor: 'printing' stamp: 'JohannesBrauer 3/16/2014 16:15'!
printOn: aStream
	aStream
		nextPutAll: self name;
		nextPutAll: '-';
		nextPutAll: self abschluss! !

Object subclass: #ManifestDozEinPlan
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DozEinPlan'!

!ManifestDozEinPlan class methodsFor: 'meta data' stamp: 'JohannesBrauer 3/2/2014 15:35'!
rejectClasses
^ #()! !

!ManifestDozEinPlan class methodsFor: 'meta data' stamp: 'JohannesBrauer 3/16/2014 15:39'!
rejectRules
^ #('BlockLintRule' 'TranslateLiteralsInMenusRule' 'ParseTreeLintRule')! !

!ManifestDozEinPlan class methodsFor: 'meta data' stamp: 'JohannesBrauer 3/17/2014 11:22'!
ruleBadMessageRuleV1TODO
^ #(#(#(#RGMethodDefinition #(#DsEinsatzplanung #exportiereDozenten #false)) #'2014-03-16T16:20:10.267000001+01:00') #(#(#RGMethodDefinition #(#DsDatenpflege #delete: #false)) #'2014-03-16T16:20:10.267+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #exportiereDozenten #false)) #'2014-03-17T11:22:37.598+01:00') )! !

!ManifestDozEinPlan class methodsFor: 'meta data' stamp: 'JohannesBrauer 3/16/2014 15:39'!
ruleClassInstVarNotInitializedRuleV1FalsePositive
^ #(#(#(#RGClassDefinition #(#DsFileLibrary)) #'2014-03-16T15:39:36.263+01:00') )! !

!ManifestDozEinPlan class methodsFor: 'meta data' stamp: 'JohannesBrauer 3/16/2014 16:20'!
ruleCollectionMessagesToExternalObjectRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#DsDozentEditor #renderInsMenueOn: #false)) #'2014-03-16T16:20:06.677+01:00') #(#(#RGMethodDefinition #(#'DsEinsatzplanung class' #initialize #true)) #'2014-03-16T16:20:06.677000001+01:00') )! !

!ManifestDozEinPlan class methodsFor: 'meta data' stamp: 'JohannesBrauer 3/17/2014 11:22'!
ruleExcessiveArgumentsRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#'DmManipel class' #name:gruppen:studienbeginn:studienrichtung:semesterZuordnung: #true)) #'2014-03-16T16:52:11.888000001+01:00') #(#(#RGMethodDefinition #(#'DmAdmin class' #modulLeser:module:studienrichtungen:zenturien:quartalsplaene:dozenten: #true)) #'2014-03-16T16:52:11.888000002+01:00') #(#(#RGMethodDefinition #(#'DmDozent class' #name:vorname:insMenue:sollStunden:auslastungen: #true)) #'2014-03-16T16:52:11.888+01:00') #(#(#RGMethodDefinition #(#'DmAdmin class' #modulLeser:module:studienrichtungen:zenturien:quartalsplaene:dozenten: #true)) #'2014-03-17T11:22:33.444+01:00') )! !

!ManifestDozEinPlan class methodsFor: 'meta data' stamp: 'JohannesBrauer 3/16/2014 16:56'!
ruleExcessiveMethodsRuleV1TODO
^ #(#(#(#RGClassDefinition #(#DmAdmin)) #'2014-03-16T16:56:00.008+01:00') #(#(#RGClassDefinition #(#DsEinsatzplanung)) #'2014-03-16T16:56:00.002+01:00') #(#(#RGClassDefinition #(#DmModul)) #'2014-03-16T16:56:00.004+01:00') )! !

!ManifestDozEinPlan class methodsFor: 'meta data' stamp: 'JohannesBrauer 3/16/2014 16:56'!
ruleExcessiveVariablesRuleV1TODO
^ #(#(#(#RGClassDefinition #(#DsEinsatzplanung)) #'2014-03-16T16:56:00.122+01:00') )! !

!ManifestDozEinPlan class methodsFor: 'meta data' stamp: 'JohannesBrauer 3/16/2014 16:20'!
ruleIfTrueReturnsRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#DmDozent #= #false)) #'2014-03-16T16:20:06.982+01:00') )! !

!ManifestDozEinPlan class methodsFor: 'meta data' stamp: 'JohannesBrauer 3/17/2014 10:10'!
ruleImplementedNotSentRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#DmModul #semester6: #false)) #'2014-03-17T09:43:24.840000005+01:00') #(#(#RGMethodDefinition #(#DmModul #semester7: #false)) #'2014-03-17T09:43:24.840000006+01:00') #(#(#RGMethodDefinition #(#DmManipel #semester1: #false)) #'2014-03-17T09:43:24.840000007+01:00') #(#(#RGMethodDefinition #(#DmManipel #semester5: #false)) #'2014-03-17T09:43:24.840000003+01:00') #(#(#RGMethodDefinition #(#DmManipel #semester4: #false)) #'2014-03-17T09:43:24.840000013+01:00') #(#(#RGMethodDefinition #(#DmModul #semester4: #false)) #'2014-03-17T09:43:24.84000001+01:00') #(#(#RGMethodDefinition #(#DmManipel #semester6: #false)) #'2014-03-17T09:43:24.84+01:00') #(#(#RGMethodDefinition #(#DmModul #semester5: #false)) #'2014-03-17T09:43:24.840000009+01:00') #(#(#RGMethodDefinition #(#DmModul #semester2: #false)) #'2014-03-17T09:43:24.840000012+01:00') #(#(#RGMethodDefinition #(#DmModul #semester3: #false)) #'2014-03-17T09:43:24.840000011+01:00') #(#(#RGMethodDefinition #(#DmModul #semester1: #false)) #'2014-03-17T09:43:24.840000008+01:00') #(#(#RGMethodDefinition #(#DmManipel #semester2: #false)) #'2014-03-17T09:43:24.840000002+01:00') #(#(#RGMethodDefinition #(#DmManipel #semester3: #false)) #'2014-03-17T09:43:24.840000004+01:00') #(#(#RGMethodDefinition #(#DmManipel #semester7: #false)) #'2014-03-17T09:43:24.840000001+01:00') #(#(#RGMethodDefinition #(#DmManipel #studienbeginnSea: #false)) #'2014-03-17T10:10:27.221+01:00') #(#(#RGMethodDefinition #(#DmModul #ab: #false)) #'2014-03-17T10:10:27.221000001+01:00') #(#(#RGMethodDefinition #(#DmAdmin #fuegeDmManipelHinzu: #false)) #'2014-03-17T10:10:27.219+01:00') #(#(#RGMethodDefinition #(#DmModul #bis: #false)) #'2014-03-17T10:10:27.221000003+01:00') #(#(#RGMethodDefinition #(#DmDozent #representBinaryOn: #false)) #'2014-03-17T10:10:27.219000001+01:00') #(#(#RGMethodDefinition #(#DmManipel #studienbeginnAsString: #false)) #'2014-03-17T10:10:27.221000004+01:00') #(#(#RGMethodDefinition #(#DmAdmin #fuegeDmDozentHinzu: #false)) #'2014-03-17T10:10:27.221000002+01:00') #(#(#RGMethodDefinition #(#DmAdmin #fuegeDmModulHinzu: #false)) #'2014-03-17T10:10:27.221000005+01:00') )! !

!ManifestDozEinPlan class methodsFor: 'meta data' stamp: 'JohannesBrauer 3/17/2014 10:10'!
ruleImplementedNotSentRuleV1TODO
^ #(#(#(#RGMethodDefinition #(#DsEinsatzplanung #dozentenAusVw #false)) #'2014-03-17T10:10:30.846+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #ausVw #false)) #'2014-03-17T10:10:30.846000001+01:00') )! !

!ManifestDozEinPlan class methodsFor: 'meta data' stamp: 'JohannesBrauer 3/16/2014 16:52'!
ruleInconsistentMethodClassificationRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#DmManipel #name #false)) #'2014-03-16T16:52:15.622+01:00') #(#(#RGMethodDefinition #(#DmDozent #name #false)) #'2014-03-16T16:52:15.622000001+01:00') #(#(#RGMethodDefinition #(#DmStudienrichtung #name #false)) #'2014-03-16T16:52:15.622000002+01:00') )! !

!ManifestDozEinPlan class methodsFor: 'meta data' stamp: 'JohannesBrauer 3/17/2014 11:22'!
ruleLawOfDemeterRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#DsManipelpflege #aktualisierePlanungAlt:neu: #false)) #'2014-03-17T10:31:32.062000007+01:00') #(#(#RGMethodDefinition #(#DsEinsatz #initialisiereAnzeigeFuerAktuellesGeschaeftsjahr #false)) #'2014-03-17T10:31:32.06200001+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #ausVw #false)) #'2014-03-17T10:31:32.062000004+01:00') #(#(#RGMethodDefinition #(#DmLehrveranstaltung #lvStunden #false)) #'2014-03-17T10:31:32.062000003+01:00') #(#(#RGMethodDefinition #(#DmQuartalsplan #liegtImGeschaeftsjahr: #false)) #'2014-03-17T10:31:32.062000006+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #laden: #false)) #'2014-03-17T10:31:32.062000011+01:00') #(#(#RGMethodDefinition #(#DsEinsatz #laden #false)) #'2014-03-17T10:31:32.062000012+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #laden #false)) #'2014-03-17T10:31:32.062+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #schreibeLvenIn:FuerManipel: #false)) #'2014-03-17T10:31:32.062000002+01:00') #(#(#RGMethodDefinition #(#DsEinsatz #laden: #false)) #'2014-03-17T10:31:32.062000005+01:00') #(#(#RGMethodDefinition #(#DmDozent #summe #false)) #'2014-03-17T10:31:32.062000008+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #initialisiereAnzeigeFuerAktuellesGeschaeftsjahr #false)) #'2014-03-17T10:31:32.062000013+01:00') #(#(#RGMethodDefinition #(#DmModul #mussModulUnterrichtetWerdenFuer:inQuartal: #false)) #'2014-03-17T10:31:32.062000014+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #schreibe:in: #false)) #'2014-03-17T10:31:32.062000001+01:00') #(#(#RGMethodDefinition #(#DmLehrveranstaltung #geschaeftsjahreszahl #false)) #'2014-03-17T10:31:32.062000009+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #schreibe:in: #false)) #'2014-03-17T11:22:37.193+01:00') #(#(#RGMethodDefinition #(#DsEinsatz #laden #false)) #'2014-03-17T11:22:37.193000005+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #laden: #false)) #'2014-03-17T11:22:37.193000007+01:00') #(#(#RGMethodDefinition #(#DsEinsatz #laden: #false)) #'2014-03-17T11:22:37.193000002+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #ausVw #false)) #'2014-03-17T11:22:37.193000004+01:00') #(#(#RGMethodDefinition #(#DsEinsatz #initialisiereAnzeigeFuerAktuellesGeschaeftsjahr #false)) #'2014-03-17T11:22:37.193000003+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #initialisiereAnzeigeFuerAktuellesGeschaeftsjahr #false)) #'2014-03-17T11:22:37.193000006+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #schreibeLvenIn:FuerManipel: #false)) #'2014-03-17T11:22:37.193000001+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #laden #false)) #'2014-03-17T11:22:37.191+01:00') )! !

!ManifestDozEinPlan class methodsFor: 'meta data' stamp: 'JohannesBrauer 3/17/2014 11:22'!
ruleLawOfDemeterRuleV1TODO
^ #(#(#(#RGMethodDefinition #(#DmLehrveranstaltung #belegeMitStandarddozentFuerQuartal:aus: #false)) #'2014-03-17T10:31:32.324+01:00') #(#(#RGMethodDefinition #(#DmAdmin #erzeugeStandardBelegungFuerQuartal: #false)) #'2014-03-17T10:31:32.324000001+01:00') #(#(#RGMethodDefinition #(#DmAdmin #erzeugeStandardBelegungFuerQuartal: #false)) #'2014-03-17T11:22:37.707+01:00') )! !

!ManifestDozEinPlan class methodsFor: 'meta data' stamp: 'JohannesBrauer 3/17/2014 11:22'!
ruleLongMethodsRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#DmAdmin #liesSemesterZuordnungAus: #false)) #'2014-03-17T11:15:30.084000001+01:00') #(#(#RGMethodDefinition #(#DsJahresuebersichtComponent #renderContentOn: #false)) #'2014-03-17T11:15:30.084000008+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #initialize #false)) #'2014-03-17T11:15:30.084000009+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #lvSpaltenDefintionen #false)) #'2014-03-17T11:15:30.084000003+01:00') #(#(#RGMethodDefinition #(#DsModulpflege #modulSpaltenDefintionen #false)) #'2014-03-17T11:15:30.084+01:00') #(#(#RGMethodDefinition #(#DsLoginComponent #renderButtonRows: #false)) #'2014-03-17T11:15:30.084000007+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #renderHeaderOn: #false)) #'2014-03-17T11:15:30.084000006+01:00') #(#(#RGMethodDefinition #(#DmAdmin #initialize #false)) #'2014-03-17T11:15:30.084000002+01:00') #(#(#RGMethodDefinition #(#DmAdmin #liesManipelAusDatei #false)) #'2014-03-17T11:15:30.084000004+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #exportiereDozenten #false)) #'2014-03-17T11:15:30.084000005+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #lvSpaltenDefintionen #false)) #'2014-03-17T11:22:33.749000001+01:00') #(#(#RGMethodDefinition #(#DmAdmin #liesManipelAusDatei #false)) #'2014-03-17T11:22:33.749000002+01:00') #(#(#RGMethodDefinition #(#DmAdmin #liesSemesterZuordnungAus: #false)) #'2014-03-17T11:22:33.746+01:00') #(#(#RGMethodDefinition #(#DmAdmin #initialize #false)) #'2014-03-17T11:22:33.749+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #exportiereDozenten #false)) #'2014-03-17T11:22:33.749000003+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #renderHeaderOn: #false)) #'2014-03-17T11:22:33.749000004+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #initialize #false)) #'2014-03-17T11:22:33.749000005+01:00') )! !

!ManifestDozEinPlan class methodsFor: 'meta data' stamp: 'JohannesBrauer 3/17/2014 11:22'!
ruleLongMethodsRuleV1TODO
^ #(#(#(#RGMethodDefinition #(#DsEinsatzplanung #ausVw #false)) #'2014-03-17T11:15:30.782000001+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #schreibeLvenIn:FuerManipel: #false)) #'2014-03-17T11:15:30.782000002+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #dozentenAusVw #false)) #'2014-03-17T11:15:30.782+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #ausVw #false)) #'2014-03-17T11:22:37.514000002+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #schreibeLvenIn:FuerManipel: #false)) #'2014-03-17T11:22:37.514000001+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #dozentenAusVw #false)) #'2014-03-17T11:22:37.514+01:00') )! !

!ManifestDozEinPlan class methodsFor: 'meta data' stamp: 'JohannesBrauer 3/16/2014 16:20'!
ruleNoClassCommentRuleV1TODO
^ #(#(#(#RGClassDefinition #(#DsManipelEditor)) #'2014-03-16T16:20:10.123000009+01:00') #(#(#RGClassDefinition #(#DsListComponent)) #'2014-03-16T16:20:10.121000003+01:00') #(#(#RGClassDefinition #(#DsModulpflege)) #'2014-03-16T16:20:10.121000005+01:00') #(#(#RGClassDefinition #(#DsItemEditor)) #'2014-03-16T16:20:10.121000004+01:00') #(#(#RGClassDefinition #(#DsModulEditor)) #'2014-03-16T16:20:10.121000006+01:00') #(#(#RGClassDefinition #(#DsManipelpflege)) #'2014-03-16T16:20:10.123000001+01:00') #(#(#RGClassDefinition #(#DsFileLibrary)) #'2014-03-16T16:20:10.123000003+01:00') #(#(#RGClassDefinition #(#DsLoginComponent)) #'2014-03-16T16:20:10.123000005+01:00') #(#(#RGClassDefinition #(#DsDozentenpflege)) #'2014-03-16T16:20:10.123+01:00') #(#(#RGClassDefinition #(#DsMenuComponent)) #'2014-03-16T16:20:10.123000008+01:00') #(#(#RGClassDefinition #(#DsDateiEditor)) #'2014-03-16T16:20:10.121000002+01:00') #(#(#RGClassDefinition #(#DsDozentEditor)) #'2014-03-16T16:20:10.123000004+01:00') #(#(#RGClassDefinition #(#DsDatensicherung)) #'2014-03-16T16:20:10.123000007+01:00') #(#(#RGClassDefinition #(#DsMessageComponent)) #'2014-03-16T16:20:10.123000006+01:00') #(#(#RGClassDefinition #(#DsJahresuebersichtComponent)) #'2014-03-16T16:20:10.123000002+01:00') #(#(#RGClassDefinition #(#DsLehrveranstaltungEditor)) #'2014-03-16T16:20:10.125+01:00') #(#(#RGClassDefinition #(#DsModulAuswahl)) #'2014-03-16T16:20:10.121+01:00') #(#(#RGClassDefinition #(#DsEinsatz)) #'2014-03-16T16:20:10.121000001+01:00') #(#(#RGClassDefinition #(#DsDatenpflege)) #'2014-03-16T16:20:10.119+01:00') )! !

!ManifestDozEinPlan class methodsFor: 'meta data' stamp: 'JohannesBrauer 3/16/2014 15:39'!
ruleTempsReadBeforeWrittenRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#DsJahresuebersichtComponent #renderContentOn: #false)) #'2014-03-16T15:39:36.375+01:00') )! !

!ManifestDozEinPlan class methodsFor: 'meta data' stamp: 'JohannesBrauer 3/17/2014 11:22'!
ruleTransformationRuleV1FalsePositive
^ #(#(#(#RGMethodDefinition #(#DsModulpflege #addSemester: #false)) #'2014-03-16T16:20:03.424+01:00') #(#(#RGMethodDefinition #(#DsDatensicherung #saveFile: #false)) #'2014-03-16T16:20:08.503000004+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #schreibeLvenIn:FuerManipel: #false)) #'2014-03-16T16:20:08.503000001+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #schreibeUeberschriftIn:Fuer: #false)) #'2014-03-16T16:20:08.503000002+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #schreibe:in: #false)) #'2014-03-16T16:20:08.503+01:00') #(#(#RGMethodDefinition #(#DmLehrveranstaltung #exportTo: #false)) #'2014-03-16T16:20:08.503000003+01:00') #(#(#RGMethodDefinition #(#DsDatenpflege #newItem: #false)) #'2014-03-16T16:20:09.514+01:00') #(#(#RGMethodDefinition #(#DsDatensicherung #download: #false)) #'2014-03-16T16:20:09.514000001+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #schreibeUeberschriftIn:Fuer: #false)) #'2014-03-17T11:22:33.951000001+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #schreibeLvenIn:FuerManipel: #false)) #'2014-03-17T11:22:33.951+01:00') #(#(#RGMethodDefinition #(#DsEinsatzplanung #schreibe:in: #false)) #'2014-03-17T11:22:33.951000002+01:00') )! !

Magnitude subclass: #DmQuartal
	instanceVariableNames: 'nr jahr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DozEinPlan'!

!DmQuartal commentStamp: '<historical>' prior: 0!
Instance Variables:
	jahr 	<Core.Integer> Jahrezahl
	nr 	<Core.Integer> 1, 2, 3 oder 4
!

!DmQuartal class methodsFor: 'instance creation' stamp: ' 15/1/14 15:24'!
from: aString
	""
	
	^self
		jahr: aString first digitValue
		nr: (aString at: 3) digitValue! !

!DmQuartal class methodsFor: 'instance creation' stamp: ' 15/1/14 15:24'!
fromString: aString
	""
	
	^self
		jahr: (aString copyFrom: 1 to: 4) asNumber
		nr: (aString at: 6) digitValue! !

!DmQuartal class methodsFor: 'instance creation' stamp: ' 15/1/14 15:24'!
jahr: anInteger nr: anotherInteger
	
	^(self new)
		jahr: anInteger;
		nr: anotherInteger;
		yourself! !

!DmQuartal methodsFor: 'arithmetic' stamp: ' 15/1/14 15:24'!
- einQuartal
	
	^self class
		jahr: self jahr - einQuartal jahr
		nr: self nr! !

!DmQuartal methodsFor: 'testing' stamp: ' 15/1/14 15:24'!
< einQuartal
	
	^self jahr < einQuartal jahr
		| (self jahr = einQuartal jahr & (self nr < einQuartal nr))! !

!DmQuartal methodsFor: 'testing' stamp: ' 15/1/14 15:24'!
= einQuartal
	
	^self jahr = einQuartal jahr & (self nr = einQuartal nr)! !

!DmQuartal methodsFor: 'converting' stamp: ' 15/1/14 15:24'!
asText
	
	^self printString asText! !

!DmQuartal methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
geschaeftsjahreszahl
	
	^self nr = 4
		ifTrue: [jahr + 1]
		ifFalse: [jahr]! !

!DmQuartal methodsFor: 'hash' stamp: ' 15/1/14 15:24'!
hash
	
	^self jahr hash bitXor: self nr hash! !

!DmQuartal methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
jahr
	
	^jahr! !

!DmQuartal methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
jahr: anObject
	
	jahr := anObject! !

!DmQuartal methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
nr
	
	^nr! !

!DmQuartal methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
nr: anObject
	
	nr := anObject! !

!DmQuartal methodsFor: 'printing' stamp: 'JohannesBrauer 3/16/2014 16:14'!
printOn: aStream
	aStream
		nextPutAll: self jahr printString;
		nextPutAll: '-';
		nextPutAll: self nr printString! !

WAFileLibrary subclass: #DsFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DozEinPlan'!

!DsFileLibrary methodsFor: 'uploaded' stamp: 'jb 1/22/2014 08:19'!
dozentenCsv
	^ 'Albert
Bartelsen
Brauer
Dehn
Friese
Guttenberg
Hauschildt
Heimrich
Henning
Herrmann
Kißig
Laubach
Netzler
NN
Nörthemann
Pfeiffer
Romeyke
Schröder
Seifert
Stuhr
Reichert
Rölz
Welzin
Wozniak
Zimmermann
'! !

!DsFileLibrary methodsFor: 'uploaded' stamp: 'jb 10/23/2019 21:36'!
doziplanCss
	
	^'body { 
 font-family:   Georgia, "Times New Roman", Times, serif; 
 font-size:   small; 
} 
  
#allcontent { 
 width:     770px; 
 padding-top:   5px; 
 padding-bottom:  5px; 
 background-color: #fff0d0; 
 margin-left:   auto; 
 margin-right:   auto; 
} 
  
*.section { 
 background-color: #ffeabf; 
} 
  
#header { 
 margin:    10px; 
} 
  
#lvenListid { 
 padding:    5px; 
 margin:    0px 5px 5px 5px; 
position:absolute; top:90px; left:100px; width:700px;height: 715px; overflow:scroll;
    } 
  
#doziStundenListid { 
 padding:    5px; 
 margin:    0px 5px 5px 5px; 
position:absolute; top:90px; left:850px; width:250px; height: 650px; overflow:scroll;
    } 

#jahresuebersicht { 
 padding:    5px; 
 margin:    0px 5px 5px 5px; 
position:absolute; top:90px; left:750px; width:250px;
    } 

#DozentenpflegeListId { 
 padding:    5px; 
 margin:    0px 5px 5px 5px; 
position:absolute; top:0px; left:200px; width:400px;height: 715px; overflow:scroll;
    } 

#ManipelpflegeListId { 
 padding:    5px; 
 margin:    0px 5px 5px 5px; 
position:absolute; top:0px; left:200px; width:1000px;
    }

#ModulpflegeListId { 
 padding:    5px; 
 margin:    0px 5px 5px 5px; 
position:absolute;  top:0px; left:150px; width: 1000px; height: 715px; overflow:scroll;
    }

#menuid { 
 padding:    1px; 
 margin:    0px 1px 1px 1px; 
} 
  
#footer { 
 color:     #204670; 
 text-align:   center; 
 padding:    15px; 
 margin:    10px; 
 clear:     right; 
}

form.eventEditor  {background-color:#FFFFCC;}
#lvEditor { position:absolute; top:-50px; left:150px; }
#dzEditor { position:absolute; top:-50px; left:0px; }
.eventEditor { display: table; } 
.eventEditor > div { display: table-row; } 
.eventEditor > div > * { display: table-cell; }

form.modulAuswahl  {background-color:#FFFFCC;}
#module { position:absolute; top:-50px; left:150px; }
.modulAuswahl  { display: table; } 
.modulAuswahl > div  { display: table-row; } 
.modulAuswahl > div  > *  { display: table-cell; } 

form.message  {background-color:#FFFFCC;}
#manipelMessage { position:absolute; top:-50px; left:150px; }
.message { display: table; } 
.message > div { display: table-row; } 
.message > div > * { display: table-cell; }'! !

!DsFileLibrary methodsFor: 'uploaded' stamp: ' 15/1/14 15:24'!
doziplanCssss
	
	^'body { 
 font-family:   Georgia, "Times New Roman", Times, serif; 
 font-size:   small; 
background-color:#FFFFCC;
} 
  
#allcontent { 
 width:     770px; 
 padding-top:   5px; 
 padding-bottom:  5px; 
 background-color: #fff0d0; 
 margin-left:   auto; 
 margin-right:   auto; 
} 
  
*.section { 
 background-color: #ffeabf; 
} 
  
#header { 
 margin:    10px; 
} 
  
#main { 
 padding:    15px; 
 margin:    0px 10px 10px 10px; 
 width:     550px; 
 float:     right; 
} 
  
#sidebar { 
 padding:    15px; 
 margin:    0px 600px 10px 10px; 
} 
  
#footer { 
 color:     #204670; 
 text-align:   center; 
 padding:    15px; 
 margin:    10px; 
 clear:     right; 
}
.eventEditor { display: table; } 
.eventEditor > div { display: table-row; } 
.eventEditor > div > * { display: table-cell; }'! !

!DsFileLibrary methodsFor: 'uploaded' stamp: 'jb 1/22/2014 08:24'!
manipelsemesterCsv
	^ 'Object,AnzahlGruppen,Studienbeginn,Studienrichtung,Abschluss,S1,S2,S3,S4,S5,S6,S7
B10,4,2009,Betriebswirtschaftslehre,Bachelor,1-1,1-3,1-4,2-2,2-4,3-3,3-4
I10,3,2009,Wirtschaftsinformatik,Bachelor,1-1,1-3,2-1,2-2,2-4,3-2,3-4
W10,4,2009,Wirtschaftsingenieurwesen,Bachelor,1-1,1-3,1-4,2-2,2-4,3-2,3-4
'! !

!DsFileLibrary methodsFor: 'uploaded' stamp: 'jb 1/22/2014 08:25'!
winfobscCsv
	^ 'Wirtschaftsinformatik,Bachelor
I0,Philosophie, 1,2,2,,,,
I1,Theoretische Grundlagen der Informatik 1,1,2,3,4,5,6,7
I2,Theoretische Grundlagen der Informatik 2,,,2,2,,,
I3,Technische Grundlagen der Informatik 1,3,3,,,,,
I4,Technische Grundlagen der Informatik 2,,,3,3,,,
I5,Programmierung 1,4,4,,,,,
I6,Programmierung 2,,,4,4,,,
I7,Algorithmen & Datenstrukturen,,,3,3,,,
I8,Programmiermethodik,,3,3,,,,
I9,Softwareproduktion,,,,,3,3,
I10,Datenbanksysteme,,3,3,,,,
I11,Mathematik 1,4,3,,,,,
I12,Mathematik 2,,,3,3,,,
I14,Internet Grundlagen,3,2,,,,,
I15,Internet Anwendungsarchitekturen,,,,,4,3,
I16,Betriebswirtschaftliche Anwendungen,,,,,3,3,
I17,Betriebl. Organisation der Informatik,,,3,3,,,
I18,Geschäftsprozessmodellierung + QM,,,,,2,2,
I19,Seminar: Ausgew. Kapitel d. Wi.-Inform.,,,,,2,2,
I20,IT-gestütztes Rechnungswesen 1,,2,,,,,
I21,IT-gestütztes Rechnungswesen 2,,,,2,,,
I27,Wahlpflichtfach 1,,,,,6,,
I28,Wahlpflichtfach 2,,,,,,6,
'! !

WASession subclass: #DsSession
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DozEinPlan'!

!DsSession methodsFor: 'login-logout' stamp: 'jb 8/7/2017 20:50'!
initialize
super initialize .
user := nil.! !

!DsSession methodsFor: 'testing' stamp: 'jb 8/7/2017 14:52'!
isLoggedIn
    ^ user isNil not! !

!DsSession methodsFor: 'login-logout' stamp: 'jb 8/7/2017 14:51'!
login: aString
    user := aString! !

!DsSession methodsFor: 'login-logout' stamp: 'jb 8/7/2017 14:52'!
logout
    user := nil! !

!DsSession methodsFor: 'accessing' stamp: 'jb 8/7/2017 14:53'!
user
    ^ user! !

WAComponent subclass: #DsDatenpflege
	instanceVariableNames: 'itemsComponent items heading myAdmin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DozEinPlan'!

!DsDatenpflege class methodsFor: 'instance creation' stamp: ' 15/1/14 15:24'!
with: aCollection andHeading: aString
	""
	
	^self basicNew initialize: aCollection heading: aString! !

!DsDatenpflege methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
aktualisierePlanungAlt: oldItem neu: newItem
	
	! !

!DsDatenpflege methodsFor: 'hooks' stamp: ' 15/1/14 15:24'!
children
	
	^Array with: self itemsComponent! !

!DsDatenpflege methodsFor: 'private' stamp: ' 15/1/14 15:24'!
cssClas
	
	^heading , 'List'! !

!DsDatenpflege methodsFor: 'private' stamp: ' 15/1/14 15:24'!
cssId
	
	^heading , 'ListId'! !

!DsDatenpflege methodsFor: 'actions' stamp: ' 15/1/14 15:24'!
delete: anItem
	
	^self halt! !

!DsDatenpflege methodsFor: 'actions' stamp: 'jb 4/1/2016 18:57'!
editItem: anItem with: anItemEditor
	
	| item |
	item := anItem copy.
	(self lightbox: (anItemEditor for: item))
		ifTrue:
			[(item istNeu: anItem)
				ifTrue: [self newItem: item]
				ifFalse: [self aktualisierePlanungAlt: anItem neu: item]]! !

!DsDatenpflege methodsFor: 'actions' stamp: 'jb 4/5/2016 16:14'!
editItem: anItem with: anItemEditor and: selectList
	
	| item |
	item := anItem copy.
	(self lightbox: (anItemEditor for: item with: selectList))
		ifTrue:
			[(item istNeu: anItem)
				ifTrue: [self newItem: item]
				ifFalse: [self aktualisierePlanungAlt: anItem neu: item]]! !

!DsDatenpflege methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
heading
	
	^heading! !

!DsDatenpflege methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
heading: anObject
	
	heading := anObject! !

!DsDatenpflege methodsFor: 'initialization' stamp: ' 15/1/14 15:24'!
initialize
	
	super initialize.
	self initializeItemsComponent! !

!DsDatenpflege methodsFor: 'initialization' stamp: 'JohannesBrauer 3/16/2014 15:13'!
initialize: aSortedCollection heading: aByteString
	
	self
		items: aSortedCollection;
		heading: aByteString;
		initialize! !

!DsDatenpflege methodsFor: 'initialization' stamp: ' 15/1/14 15:24'!
initializeItemsComponent
	
	self subclassResponsibility! !

!DsDatenpflege methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
items
	
	^items! !

!DsDatenpflege methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
items: aSortedCollection
	
	items := aSortedCollection! !

!DsDatenpflege methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
itemsComponent
	
	^itemsComponent! !

!DsDatenpflege methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
itemsComponent: aDozEinPlanDoziplanListSea
	
	itemsComponent := aDozEinPlanDoziplanListSea! !

!DsDatenpflege methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
myAdmin
	
	^myAdmin! !

!DsDatenpflege methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
myAdmin: anObject
	
	myAdmin := anObject! !

!DsDatenpflege methodsFor: 'change messages' stamp: 'jb 1/16/2014 08:06'!
newItem: aDozEinPlanItem
	| selector |
	selector := ('fuege' , aDozEinPlanItem class name asString , 'Hinzu:') asSymbol.
	self myAdmin perform: selector with: aDozEinPlanItem! !

!DsDatenpflege methodsFor: 'rendering' stamp: 'JohannesBrauer 3/16/2014 15:14'!
renderButtonsOn: html
	
	(html form)
		with:
				[(html submitButton)
						callback: [self answer: true];
						value: 'Schließen']! !

!DsDatenpflege methodsFor: 'rendering' stamp: 'JohannesBrauer 3/16/2014 15:14'!
renderContentOn: html
	
	(html heading)
		level: 2;
		with: self heading.
	(html div)
		class: self cssClas;
		id: self cssId;
		with: self itemsComponent.
	self renderButtonsOn: html! !

!DsDatenpflege methodsFor: 'updating' stamp: 'JohannesBrauer 3/16/2014 15:14'!
updateRoot: anHtmlRoot
	
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: self heading.
	(anHtmlRoot link)
		type: 'text/css';
		beStylesheet;
		addAll;
		url: DsFileLibrary / 'doziplan.css'! !

DsDatenpflege subclass: #DsDatensicherung
	instanceVariableNames: 'dateiname data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DozEinPlan'!

!DsDatensicherung class methodsFor: 'accessing' stamp: 'JohannesBrauer 2/8/2014 15:23'!
dateien
	| disk dir |
	disk := FileSystem disk.
	dir := disk workingDirectory / 'datensicherung'.
	^ dir entries collect: [ :d | d reference ]! !

!DsDatensicherung class methodsFor: 'instance creation' stamp: 'JohannesBrauer 2/8/2014 14:01'!
with: model andHeading: aString
	""
	
	^(super
		with:  self dateien
		andHeading: aString) myAdmin: model! !

!DsDatensicherung methodsFor: 'accessing' stamp: 'JohannesBrauer 2/8/2014 20:16'!
data
	^ data! !

!DsDatensicherung methodsFor: 'accessing' stamp: 'JohannesBrauer 2/8/2014 20:16'!
data: fileContents
	data := fileContents ! !

!DsDatensicherung methodsFor: 'accessing' stamp: 'JohannesBrauer 2/8/2014 19:02'!
dateiname
	^ dateiname! !

!DsDatensicherung methodsFor: 'accessing' stamp: 'JohannesBrauer 2/8/2014 19:02'!
dateiname: aString
	dateiname := aString ! !

!DsDatensicherung methodsFor: 'actions' stamp: 'JohannesBrauer 2/8/2014 19:54'!
delete: aFileReferece
	aFileReferece delete.
	self items: self class dateien.
	self itemsComponent rows: self items! !

!DsDatensicherung methodsFor: 'actions' stamp: 'JohannesBrauer 3/16/2014 15:48'!
download: aFileReference
	| daten stream |
	stream := FileStream fileNamed: aFileReference fullName.
	stream binary.
	daten := stream contents.
	stream close.
	self requestContext
		respond: [ :response | 
			response
				binary;
				contentType: nil;
				document: daten asString ;
				attachmentWithFileName: aFileReference basename ]! !

!DsDatensicherung methodsFor: 'actions' stamp: 'JohannesBrauer 3/2/2014 17:43'!
editDatei: einDatei
	
	self editItem: einDatei with: DsDateiEditor! !

!DsDatensicherung methodsFor: 'actions' stamp: 'JohannesBrauer 3/3/2014 10:48'!
editItem: anItem with: anItemEditor
	
	(self lightbox: (anItemEditor for: anItem ))
		ifTrue:
			[ ^ self]! !

!DsDatensicherung methodsFor: 'initialization' stamp: 'JohannesBrauer 2/8/2014 20:14'!
initializeItemsComponent
	
	self
		itemsComponent:
				(DsListComponent
						withItems: self items
						andTableTitle: '');
		sicherungSpaltenDefintionen.
	(self itemsComponent)
		rowColors: #(#lightblue #lightyellow);
		rowPeriod: 1.
	self itemsComponent rows: self items.
	self data: nil! !

!DsDatensicherung methodsFor: 'actions' stamp: 'jb 8/12/2017 14:20'!
ladenAus: aFileRefence
	| stream objects |
	stream := aFileRefence readStream.
	stream := SixxReadStream on: stream.
	objects := stream contents.
	stream close.
	^ self data: objects! !

!DsDatensicherung methodsFor: 'actions' stamp: 'jb 8/10/2017 17:19'!
ladenAusFUEL: aFileRefence
	 ^self data: (FLMaterializer materializeFromFileNamed: aFileRefence).
! !

!DsDatensicherung methodsFor: 'rendering' stamp: 'JohannesBrauer 3/6/2014 22:58'!
renderButtonsOn: html
	self renderDatenSichernOn: html.
	self renderDatenHochladenOn: html.
	html form
		with: [ 
			html submitButton
				callback: [ self answer: data ];
				value: 'Schließen' ]! !

!DsDatensicherung methodsFor: 'rendering' stamp: 'JohannesBrauer 3/6/2014 22:58'!
renderDatenHochladenOn: html
	html heading
		level: 3;
		with: 'Planungsdaten hochladen'.
	html form
		multipart;
		with: [ 
					html fileUpload callback: [ :value | self saveFile: value ].
					html submitButton
						callback: [ 
									self items: self class dateien.
									self itemsComponent rows: self items ];
						with: 'Send file' ].
	html horizontalRule! !

!DsDatensicherung methodsFor: 'rendering' stamp: 'JohannesBrauer 3/17/2014 10:39'!
renderDatenSichernOn: html
	self dateiname: 'eplan' , DateAndTime now truncated printString , '.db'.
	self renderHeaderOn: html.
	html form
		with: [ 
			html text: 'Daten in Datei mit dem Namen '.
			html textInput
				size: 40;
				callback: [ :input | self dateiname: input ];
				with: self dateiname.
			html submitButton
				callback: [ self sichern ];
				value: 'sichern'.
			self renderFooterOn: html ]! !

!DsDatensicherung methodsFor: 'rendering' stamp: 'JohannesBrauer 3/17/2014 10:39'!
renderFooterOn: html
	html break.
	^ html horizontalRule! !

!DsDatensicherung methodsFor: 'rendering' stamp: 'JohannesBrauer 3/17/2014 10:36'!
renderHeaderOn: html
	html horizontalRule.
	html heading
		level: 3;
		with: 'Planungsdaten in Datei speichern'! !

!DsDatensicherung methodsFor: 'actions' stamp: 'JohannesBrauer 3/2/2014 17:27'!
saveFile: aWAFile
	| filename disk dir file |
	filename := aWAFile fileName.	"UUID new asString, '.zip'."
	disk := FileSystem disk.
	dir := disk workingDirectory / 'datensicherung'.
	file := dir / filename.
	file exists
		ifFalse: [ 
			file writeStream
				nextPutAll: aWAFile rawContents;
				close ]
			ifTrue: [ self inform: 'Datei mit diesem Namen existiert bereits.' ]! !

!DsDatensicherung methodsFor: 'actions' stamp: 'jb 11/11/2019 21:11'!
sichern
	| disk dir stream |
	disk := FileSystem disk.
	dir := disk workingDirectory / 'datensicherung'.
	stream := SixxWriteStream new stream: (dir / self dateiname) writeStream.
	stream
		nextPutAll: (Array with: (self myAdmin modulLeser: nil) with: DsEinsatzplanung aktuellesGeschaeftsjahr).
	stream close! !

!DsDatensicherung methodsFor: 'actions' stamp: 'jb 8/12/2017 13:50'!
sichernFUEL
	FLSerializer
		serialize: (Array with: self myAdmin with: DsEinsatzplanung aktuellesGeschaeftsjahr)
		toFileNamed: 'datensicherung/' , self dateiname.
	self items: self class dateien.
	self itemsComponent rows: self items! !

!DsDatensicherung methodsFor: 'actions' stamp: 'jb 8/12/2017 13:50'!
sichernFUELs
	FLSerializer
		serialize: (Array with: self myAdmin with: DsEinsatzplanung aktuellesGeschaeftsjahr)
		toFileNamed: 'datensicherung/' , self dateiname.
	self items: self class dateien.
	self itemsComponent rows: self items! !

!DsDatensicherung methodsFor: 'initialization' stamp: 'JohannesBrauer 3/4/2014 20:33'!
sicherungSpaltenDefintionen
	self itemsComponent
		columns:
			(OrderedCollection new
				add: (WAReportColumn selector: #basename title: 'Dateiname' onClick: [:datei | self editDatei: datei]);
				add: (WAReportColumn selector: #creationTime title: 'Erzeugt am');
				add:
						(WAReportColumn new
								title: 'Aktion';
								valueBlock: [ :datei | 'entfernen' ];
								clickBlock: [ :datei | self delete: datei ];
								yourself);
				add:
						(WAReportColumn new
								title: 'Aktion';
								valueBlock: [ :datei | 'laden' ];
								clickBlock: [ :datei | self ladenAus:  datei. self answer: self data ];
								yourself);
				add:
						(WAReportColumn new
								title: 'Aktion';
								valueBlock: [ :datei | 'daunlohden' ];
								clickBlock: [ :datei | self download:  datei ];
								yourself);
					yourself)! !

DsDatenpflege subclass: #DsDozentenpflege
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DozEinPlan'!

!DsDozentenpflege class methodsFor: 'instance creation' stamp: 'JohannesBrauer 2/8/2014 14:00'!
with: model andHeading: aString
	""
	^(super
		with: model dozenten
		andHeading: aString) myAdmin: model! !

!DsDozentenpflege methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
aktualisierePlanungAlt: oldItem neu: newItem
	
	oldItem ueberNimmDatenVon: newItem! !

!DsDozentenpflege methodsFor: 'actions' stamp: ' 15/1/14 15:24'!
delete: einDozent
	
	self myAdmin entferneDozent: einDozent! !

!DsDozentenpflege methodsFor: 'column-defintion' stamp: 'jb 1/25/2014 23:23'!
dozentenSpaltenDefintionen
	
	self itemsComponent
		columns:
			((OrderedCollection new)
				add:
						(WAReportColumn
								selector: #name
								title: 'Name'
								onClick: [:dozent | self editDozent: dozent]);
				add: (WAReportColumn selector: #vorname title: 'Vorname');
				add: (WAReportColumn selector: #insMenueJaNein title: 'ins Menue');
				add: (WAReportColumn selector: #sollStunden title: 'Stundensoll');
				add:
						((WAReportColumn new)
								title: 'Aktion';
								valueBlock: [:dozent | 'entfernen'];
								clickBlock: [:dozent | self delete: dozent];
								yourself);
				yourself)! !

!DsDozentenpflege methodsFor: 'dozentenPflege' stamp: ' 15/1/14 15:24'!
editDozent: einDozent
	
	self editItem: einDozent with: DsDozentEditor! !

!DsDozentenpflege methodsFor: 'initialization' stamp: ' 15/1/14 15:24'!
initializeItemsComponent
	
	self
		itemsComponent:
				(DsListComponent
						withItems: self items
						andTableTitle: '');
		dozentenSpaltenDefintionen.
	(self itemsComponent)
		rowColors: #(#lightblue #lightyellow);
		rowPeriod: 1.
	self itemsComponent rows: self items! !

DsDatenpflege subclass: #DsManipelpflege
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DozEinPlan'!

!DsManipelpflege class methodsFor: 'instance creation' stamp: ' 15/1/14 15:24'!
with: model andHeading: aString
	""
	
	^(super
		with: model manipel
		andHeading: aString) myAdmin: model! !

!DsManipelpflege methodsFor: 'planung' stamp: ' 15/1/14 15:24'!
aktualisierePlanungAlt: altManipel neu: neuManipel
	
	altManipel jahrSemesterZuordnung
		keysAndValuesDo:
			[:quartal :semester | 
			(neuManipel jahrSemesterZuordnung keyAtValue: semester) = quartal
				ifFalse:
					[self myAdmin
						bewegeLehranstaltungenFuerManipel: altManipel
						aus: (altManipel semesterNachQuartal: semester)
						in: (neuManipel semesterNachQuartal: semester)]].
	altManipel ueberNimmDatenVon: neuManipel! !

!DsManipelpflege methodsFor: 'actions' stamp: ' 15/1/14 15:24'!
delete: aDozEinPlanManipel
	
	self manipelEntfernen: aDozEinPlanManipel! !

!DsManipelpflege methodsFor: 'editing' stamp: 'jb 4/5/2016 17:03'!
editManipel: aDozEinPlanManipel
	self
		editItem: aDozEinPlanManipel
		with: DsManipelEditor
		and: (myAdmin studienrichtungen select: [ :sr | sr abschluss = 'Bachelor' ])! !

!DsManipelpflege methodsFor: 'initialization' stamp: ' 15/1/14 15:24'!
initializeItemsComponent
	
	self
		itemsComponent:
				(DsListComponent
						withItems: self items
						andTableTitle: '');
		manipelSpaltenDefintionen.
	(self itemsComponent)
		rowColors: #(#lightblue #lightyellow);
		rowPeriod: 1.
	self itemsComponent rows: self items! !

!DsManipelpflege methodsFor: 'actions' stamp: ' 15/1/14 15:24'!
manipelEntfernen: einManipel
	
	(self myAdmin darfManipelEntferntWerden: einManipel)
		ifTrue: [self myAdmin entferneManipel: einManipel]
		ifFalse:
			[self
				lightbox:
					(DsMessageComponent warn:
							'Manipel ist noch in Lehrveranstaltungen verplant,  kann daher nicht entfernt werden')]! !

!DsManipelpflege methodsFor: 'column-definition' stamp: 'jb 8/3/2017 22:39'!
manipelSpaltenDefintionen
	self itemsComponent 
		columns:
			(OrderedCollection new
				add: (WAReportColumn selector: #name title: 'Name' onClick: [ :t1 | self editManipel: t1 ]);
				add: (WAReportColumn selector: #studienrichtung title: 'Studienrichtung');
				add: (WAReportColumn selector: #anzahlGruppen title: 'Grppn');
				add: (WAReportColumn selector: #studienbeginnAsString title: 'Studienbeginn');
				add: (WAReportColumn selector: #semester1 title: '1. Sem.');
				add: (WAReportColumn selector: #semester2 title: '2. Sem.');
				add: (WAReportColumn selector: #semester3 title: '3. Sem.');
				add: (WAReportColumn selector: #semester4 title: '4. Sem.');
				add: (WAReportColumn selector: #semester5 title: '5. Sem.');
				add: (WAReportColumn selector: #semester6 title: '6. Sem.');
				add: (WAReportColumn selector: #semester7 title: '7. Sem.');
				add:
						(WAReportColumn new
								title: 'Aktion';
								valueBlock: [ :t1 | 'entfernen' ];
								clickBlock: [ :t1 | self delete: t1 ];
								sortBlock: nil;
								yourself);
				yourself).
	^ self! !

DsDatenpflege subclass: #DsModulpflege
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DozEinPlan'!

!DsModulpflege class methodsFor: 'instance creation' stamp: ' 15/1/14 15:24'!
with: model andHeading: aString
	""
	
	^(super
		with: model module
		andHeading: aString) myAdmin: model! !

!DsModulpflege methodsFor: 'column-definition' stamp: ' 15/1/14 15:24'!
addSemester: spalten
	
	1
		to: 7
		do:
			[:sem | 
			| selector |
			selector := ('semester' , sem printString) asSymbol.
			spalten
				add:
						((WAReportColumn new)
								selector: selector;
								valueBlock:
										[:value | 
											(value perform: selector)
												ifNil: ['']
												ifNotNil: [value perform: selector]];
								sortBlock: nil;
								title: 'S' , sem printString;
								yourself);
				yourself]! !

!DsModulpflege methodsFor: 'planung' stamp: 'jb 5/27/2016 21:28'!
aktualisierePlanungAlt: aDozEinPlanModul neu: aDozEinPlanModul2
	
	| gueltigkeitGeaendert |
	gueltigkeitGeaendert := aDozEinPlanModul gueltigkeitGeaendert:
			aDozEinPlanModul2.
	aDozEinPlanModul ueberNimmDatenVon: aDozEinPlanModul2.
	gueltigkeitGeaendert
		ifTrue: [self myAdmin aktualisierePlanungFuer: aDozEinPlanModul]! !

!DsModulpflege methodsFor: 'actions' stamp: ' 15/1/14 15:24'!
delete: aDozEinPlanManipel
	
	self modulEntfernen: aDozEinPlanManipel! !

!DsModulpflege methodsFor: 'editing' stamp: 'jb 4/5/2016 17:36'!
editModul: aDozEinPlanModul
	self
		editItem: aDozEinPlanModul
		with: DsModulEditor
		and: (myAdmin studienrichtungen select: [ :sr | sr abschluss = 'Bachelor' ])! !

!DsModulpflege methodsFor: 'initialization' stamp: ' 15/1/14 15:24'!
initializeItemsComponent
	
	self
		itemsComponent:
				(DsListComponent
						withItems: self items
						andTableTitle: '');
		modulSpaltenDefintionen.
	(self itemsComponent)
		rowColors: #(#lightblue #lightyellow);
		rowPeriod: 1.
	self itemsComponent rows: self items! !

!DsModulpflege methodsFor: 'editing' stamp: ' 15/1/14 15:24'!
modulEntfernen: aDozEinPlanModul
	
	(self myAdmin darfModulEntferntWerden: aDozEinPlanModul)
		ifTrue: [self myAdmin entferneModul: aDozEinPlanModul]
		ifFalse:
			[self
				lightbox:
					(DsMessageComponent warn:
							'Modul ist noch in Lehrveranstaltungen verplant,  kann daher nicht entfernt werden')]! !

!DsModulpflege methodsFor: 'editing' stamp: ' 15/1/14 15:24'!
modulHinzufuegen: einModul
	
	self myAdmin dupliziereModul: einModul! !

!DsModulpflege methodsFor: 'column-definition' stamp: 'JohannesBrauer 3/16/2014 15:17'!
modulSpaltenDefintionen
	
	| spalten |
	spalten := OrderedCollection new.
	spalten
		add:
				(WAReportColumn
						selector: #modulNummer
						title: 'Nr.'
						onClick: [:item | self editModul: item]);
		add: (WAReportColumn selector: #modulName title: 'Name');
		add: (WAReportColumn selector: #studienrichtung title: 'Studienrichtung').
	self addSemester: spalten.
	spalten
		add: (WAReportColumn selector: #ab title: 'ab Stdnbgnn');
		add: (WAReportColumn selector: #bis title: 'bis Stdnbgnn');
		add:
				((WAReportColumn new)
						title: 'Aktion';
						valueBlock: [:modul | 'entfernen'];
						clickBlock: [:modul | self delete: modul];
						sortBlock: nil;
						yourself);
		add:
				((WAReportColumn new)
						title: 'Aktion';
						valueBlock: [:modul | 'duplizieren'];
						clickBlock: [:modul | self modulHinzufuegen: modul];
						sortBlock: nil;
						yourself).
	self itemsComponent columns: spalten! !

WAComponent subclass: #DsEinsatz
	instanceVariableNames: 'myAdmin geschaeftsjahr sicherungComponent quartal lehrveranstaltungenComponent ausgewaehlterDozent jahresUebersichtComponent quartalsListe loginComponent children'
	classVariableNames: 'AktuellesGeschaeftsjahr'
	poolDictionaries: ''
	category: 'DozEinPlan'!

!DsEinsatz class methodsFor: 'class initialization' stamp: 'jb 8/7/2017 20:37'!
initialize
	"self initialize"

	| app |
	super initialize.
	app := (WAAdmin register: self asApplicationAt: 'Dozenteneinsatz')
		"addLibrary: PTDevelopmentLibrary;
		addLibrary: SUDevelopmentLibrary;"
		preferenceAt: #sessionClass put: DsSession ;
		yourself.! !

DsEinsatz initialize!

!DsEinsatz methodsFor: 'initialization' stamp: 'JohannesBrauer 2/17/2014 21:27'!
aktualisiereAnzeigeFuerAktuellesGeschaeftsjahr
	
	self initialisiereAnzeigeFuerAktuellesGeschaeftsjahr.
	self lehrveranstaltungenComponent items: self myAdmin menueDozenten! !

!DsEinsatz methodsFor: 'change messages' stamp: 'JohannesBrauer 2/23/2014 18:40'!
aktualisiereJahresuebersicht
	self jahresUebersichtComponent
		lehrveranstaltungen:
				(self myAdmin lehrveranstaltungenInGjahr: self geschaeftsjahr fuerDozent: self ausgewaehlterDozent);
		geschaeftsjahr: self geschaeftsjahr! !

!DsEinsatz methodsFor: 'accessing' stamp: 'JohannesBrauer 2/18/2014 22:49'!
ausgewaehlterDozent
	^ausgewaehlterDozent! !

!DsEinsatz methodsFor: 'accessing' stamp: 'JohannesBrauer 2/18/2014 23:08'!
ausgewaehlterDozent: aDmDozent 

	ausgewaehlterDozent := aDmDozent! !

!DsEinsatz methodsFor: 'change messages' stamp: 'JohannesBrauer 2/23/2014 18:42'!
changedDozent
	self lehrveranstaltungenComponent
		rows: (self myAdmin lehrveranstaltungenInGjahr: self geschaeftsjahr fuerDozent: self ausgewaehlterDozent).
	self aktualisiereJahresuebersicht ! !

!DsEinsatz methodsFor: 'change messages' stamp: 'JohannesBrauer 2/23/2014 18:43'!
changedGeschaeftsjahr: aSmallInteger
	self geschaeftsjahr: aSmallInteger.
	self changedDozent.
	self aktualisiereJahresuebersicht! !

!DsEinsatz methodsFor: 'hooks' stamp: 'JohannesBrauer 3/18/2014 16:13'!
children
	
	^children ifNil: [ children := Bag new ]! !

!DsEinsatz methodsFor: 'accessing' stamp: 'JohannesBrauer 2/17/2014 19:48'!
geschaeftsjahr

	^ geschaeftsjahr! !

!DsEinsatz methodsFor: 'accessing' stamp: 'JohannesBrauer 2/17/2014 19:44'!
geschaeftsjahr: anInteger
	geschaeftsjahr := anInteger ! !

!DsEinsatz methodsFor: 'initialization' stamp: 'JohannesBrauer 2/17/2014 21:33'!
initialisiereAnzeigeFuerAktuellesGeschaeftsjahr
	
	self
		quartal:
			(self myAdmin quartaleImGeschaeftsjahr: self geschaeftsjahr )
				asSortedCollection first.
	self
		quartalsListe:
			(self myAdmin quartaleImGeschaeftsjahr: self geschaeftsjahr )
				asSortedCollection! !

!DsEinsatz methodsFor: 'initialization' stamp: 'jb 8/7/2017 20:44'!
initialize
	"initialize our components"

	super initialize.
	self
		myAdmin: DmAdmin new;
		geschaeftsjahr: AktuellesGeschaeftsjahr;
		ausgewaehlterDozent: DmDozent nn;
		initializeLvComponent;
		initializeJahresuebersichtComponent;
		laden.
	self initializeLoginComponent! !

!DsEinsatz methodsFor: 'initialization' stamp: 'JohannesBrauer 2/23/2014 17:01'!
initializeJahresuebersichtComponent


	self jahresUebersichtComponent: DsJahresuebersichtComponent new
	
! !

!DsEinsatz methodsFor: 'initialization' stamp: 'jb 8/7/2017 20:29'!
initializeLoginComponent
	self loginComponent: (DsLoginComponent new).
	self loginComponent onAnswer: [ :user | user ifNotNil: [ :u | self session login: u ] ].
	self children add: self loginComponent.
	self standardbenutzerAnlegen! !

!DsEinsatz methodsFor: 'initialization' stamp: 'JohannesBrauer 2/17/2014 21:58'!
initializeLvComponent
	
	self
		lehrveranstaltungenComponent:
				(DsListComponent
						withItems: self myAdmin dozenten
						andTableTitle: 'Lehrveranstaltungen');
		lvSpaltenDefintionen.
	(self lehrveranstaltungenComponent)
		rows: self myAdmin alleLehrveranstaltungen;
		rowColors: #(#lightblue #lightyellow);
		rowPeriod: 1! !

!DsEinsatz methodsFor: 'accessing' stamp: 'JohannesBrauer 2/23/2014 16:57'!
jahresUebersichtComponent

	^ jahresUebersichtComponent! !

!DsEinsatz methodsFor: 'accessing' stamp: 'JohannesBrauer 2/23/2014 17:01'!
jahresUebersichtComponent: aDsJahresuebersichtComponent 
	jahresUebersichtComponent := aDsJahresuebersichtComponent! !

!DsEinsatz methodsFor: 'actions' stamp: 'jb 8/12/2017 14:24'!
laden
	| disk dir file stream objects |
	disk := FileSystem disk.
	dir := disk workingDirectory / 'datensicherung'.
	file := (dir entries select: [ :d | d reference path basename = 'eplan.db' ]) first.
	stream := file readStream.
	stream := SixxReadStream on: stream.
	objects := stream contents.
	stream close.
	self laden: objects! !

!DsEinsatz methodsFor: 'actions' stamp: 'JohannesBrauer 3/16/2014 16:17'!
laden: data
	self myAdmin: (data first).
	self geschaeftsjahr: (data at: 2).
	DmDozent nn: (self myAdmin dozenten select: [ :d | d name = 'NN' ]) first.
	self aktualisiereAnzeigeFuerAktuellesGeschaeftsjahr.	"self myAdmin definiereStandardbelegungen."
	self changedDozent.
	self aktualisiereJahresuebersicht! !

!DsEinsatz methodsFor: 'actions' stamp: 'jb 8/12/2017 14:23'!
ladenFUEL
	| disk dir file |
	disk := FileSystem disk.
	dir := disk workingDirectory / 'datensicherung'.
	file := (dir entries select: [ :d | d reference path basename = 'eplan.db' ]) first.
	self laden: (FLMaterializer materializeFromFileNamed: file)! !

!DsEinsatz methodsFor: 'accessing' stamp: 'JohannesBrauer 2/17/2014 21:59'!
lehrveranstaltungenComponent

	^lehrveranstaltungenComponent! !

!DsEinsatz methodsFor: 'accessing' stamp: 'JohannesBrauer 2/17/2014 22:07'!
lehrveranstaltungenComponent: aDsListComponent 

	lehrveranstaltungenComponent := aDsListComponent! !

!DsEinsatz methodsFor: 'accessing' stamp: 'JohannesBrauer 3/18/2014 16:10'!
loginComponent
	^ loginComponent! !

!DsEinsatz methodsFor: 'accessing' stamp: 'JohannesBrauer 3/18/2014 16:10'!
loginComponent: aDsLoginComponent 
	loginComponent := aDsLoginComponent! !

!DsEinsatz methodsFor: 'lehrveranstaltungen' stamp: 'JohannesBrauer 2/19/2014 19:22'!
lvSpaltenDefintionen
	self lehrveranstaltungenComponent
		columns:
			(OrderedCollection new
				add: ((WAReportColumn selector: #modul title: 'Modul') sortBlock: [ :x :y | x modulName <= y modulName ]);
				add: ((WAReportColumn selector: #manipel title: 'Mnpl') sortBlock: [ :x :y | x name <= y name ]);
				add: (WAReportColumn selector: #semester title: 'Smstr');
				add: (WAReportColumn selector: #semesterWochenstunden title: 'SWS');
				add: (WAReportColumn selector: #wiederholungsFaktorGerundet title: 'WdhFkt');
				add: (WAReportColumn selector: #anzahlGruppen title: 'Grpn');
				add: (WAReportColumn selector: #quartal title: 'Quartal');
				add: (WAReportColumn selector: #lvStundenGerundet title: 'Lv-Stunden');
				yourself)! !

!DsEinsatz methodsFor: 'accessing' stamp: 'JohannesBrauer 2/17/2014 19:45'!
myAdmin
	^ myAdmin! !

!DsEinsatz methodsFor: 'accessing' stamp: 'JohannesBrauer 2/17/2014 19:43'!
myAdmin: aDmAdmin 
	myAdmin := aDmAdmin! !

!DsEinsatz methodsFor: 'accessing' stamp: 'JohannesBrauer 2/17/2014 22:31'!
quartal
	^ quartal! !

!DsEinsatz methodsFor: 'accessing' stamp: 'JohannesBrauer 2/17/2014 21:35'!
quartal: aDmQuartal 
	quartal :=  aDmQuartal ! !

!DsEinsatz methodsFor: 'accessing' stamp: 'JohannesBrauer 3/16/2014 15:28'!
quartalsListe: aSortedCollection 
	quartalsListe := aSortedCollection! !

!DsEinsatz methodsFor: 'rendering' stamp: 'jb 8/7/2017 20:42'!
renderContentOn: html
	html heading
		level: 2;
		with: 'Dozenteneinsatz'.
	html div
		id: '';
		with: [ 
					self session isLoggedIn 
						ifFalse: [ html render: loginComponent ]
						ifTrue: [ 
							self renderHeaderOn: html.
							html horizontalRule.
							self renderLehrveranstaltungenComponent: html.
							self renderJahresuebersichtComponent: html ] ]! !

!DsEinsatz methodsFor: 'rendering' stamp: 'JohannesBrauer 2/19/2014 18:44'!
renderDozentOn: html
	html render: 'Dozent: '.
	html select
		list: self myAdmin dozenten;
		selected: self ausgewaehlterDozent ;
		callback: [ :value | 
					self ausgewaehlterDozent: value.
					self changedDozent ]! !

!DsEinsatz methodsFor: 'rendering' stamp: 'JohannesBrauer 2/21/2014 23:47'!
renderGeschaeftsjahrOn: html

	| jahrezuzeigen |
	jahrezuzeigen := self myAdmin geschaeftsjahre asSortedCollection.
	html render: 'Geschäftsjahr: '.
	html select
		list: (jahrezuzeigen allButFirst: jahrezuzeigen size - (3 min: jahrezuzeigen size ) ) ;
		selected: self geschaeftsjahr;
		callback: [ :value | self changedGeschaeftsjahr: value asNumber ]! !

!DsEinsatz methodsFor: 'rendering' stamp: 'JohannesBrauer 3/18/2014 16:33'!
renderHeaderOn: html
	html
		form: [ 
			html
				div: [ 
					self renderGeschaeftsjahrOn: html.
					html space.
					self renderDozentOn: html.
					html submitButton:  'Los!!']]! !

!DsEinsatz methodsFor: 'rendering' stamp: 'JohannesBrauer 2/23/2014 19:06'!
renderJahresuebersichtComponent: html
	html div
		id: 'jahresuebersicht';
		with: self jahresUebersichtComponent! !

!DsEinsatz methodsFor: 'rendering' stamp: 'JohannesBrauer 3/16/2014 15:14'!
renderLehrveranstaltungenComponent: html
	
	(html div)
		with: self lehrveranstaltungenComponent! !

!DsEinsatz methodsFor: 'accessing' stamp: 'JohannesBrauer 2/17/2014 20:27'!
sicherungComponent
	^ sicherungComponent! !

!DsEinsatz methodsFor: 'accessing' stamp: 'JohannesBrauer 2/17/2014 20:26'!
sicherungComponent: aDsDatensicherung 
	sicherungComponent := aDsDatensicherung ! !

!DsEinsatz methodsFor: 'benutzer' stamp: 'jb 8/7/2017 20:42'!
standardbenutzerAnlegen

self loginComponent addUser: 'fachbereich' withPassword: 'informatik' .
! !

!DsEinsatz methodsFor: 'updating' stamp: 'JohannesBrauer 3/16/2014 15:15'!
updateRoot: anHtmlRoot
	
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'Dozenteneinsatz'.
	(anHtmlRoot link)
		type: 'text/css';
		beStylesheet;
		addAll;
		url: DsFileLibrary / 'doziplan.css'! !

WAComponent subclass: #DsEinsatzplanung
	instanceVariableNames: 'myAdmin lehrveranstaltungenComponent menuComponent geschaeftsjahr quartal quartalsListe dozentenStundenComponent lehrveranstaltungen dozentenComponent manipelComponent moduleComponent moduleSelectionComponent sicherungComponent loginComponent children'
	classVariableNames: 'AktuellesGeschaeftsjahr'
	poolDictionaries: ''
	category: 'DozEinPlan'!

!DsEinsatzplanung commentStamp: '<historical>' prior: 0!
DsEinsatzplanung ist die Hauptkomponente der Dozenteinsatzplanung.

Instance Variables
	dozentenComponent	<MessageForwarder | Object | ProtoObject | ProtoObject | Proxy | WeakProxy>	description of dozentenComponent
	dozentenStundenComponent	<WATableReport>	description of dozentenStundenComponent
	geschaeftsjahr	<AbstractProxy | Object | ProtoObject>	description of geschaeftsjahr
	lehrveranstaltungen	<MessageForwarder | Object | ProtoObject | ProtoObject | Proxy | WeakProxy>	description of lehrveranstaltungen
	lehrveranstaltungenComponent	<DsListComponent>	description of lehrveranstaltungenComponent
	manipelComponent	<MessageForwarder | Object | ProtoObject | ProtoObject | Proxy | WeakProxy>	description of manipelComponent
	menuComponent	<MessageForwarder | Object | ProtoObject | ProtoObject | Proxy | WeakProxy>	description of menuComponent
	moduleComponent	<MessageForwarder | Object | ProtoObject | ProtoObject | Proxy | WeakProxy>	description of moduleComponent
	myAdmin	<Admin>	description of myAdmin
	quartal	<ValueModel>	description of quartal
	quartalsListe	<AHSHistory | AHSOutline | GlorpVirtualCollection | JQueryInstance | PostgreSQLQueryResultList | SequenceableCollection | TripleEDE | ValueWithParametersField>	description of quartalsListe

!

!DsEinsatzplanung class methodsFor: 'accessing' stamp: 'jb 1/15/2014 20:41'!
aktuellesGeschaeftsjahr
	^AktuellesGeschaeftsjahr ! !

!DsEinsatzplanung class methodsFor: 'accessing' stamp: 'jb 1/15/2014 20:42'!
aktuellesGeschaeftsjahr: anInteger
	AktuellesGeschaeftsjahr := anInteger ! !

!DsEinsatzplanung class methodsFor: 'testing' stamp: ' 15/1/14 15:24'!
canBeRoot
	
	^true! !

!DsEinsatzplanung class methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
description
	
	^'Dozenten-Einsatzplanung'! !

!DsEinsatzplanung class methodsFor: 'class initialization' stamp: 'jb 8/8/2017 00:00'!
initialize
	"DsEinsatzplanung initialize"

	| app |
	super initialize.
	app := WAAdmin register: self asApplicationAt: 'Dozenteneinsatzplanung'.
	app preferenceAt: #sessionClass put: DsSession.
	app addLibrary: PTDevelopmentLibrary.
	app addLibrary: SUDevelopmentLibrary.
	^ app! !

DsEinsatzplanung initialize!

!DsEinsatzplanung methodsFor: 'initialization' stamp: ' 15/1/14 15:24'!
aktualisiereAnzeigeFuerAktuellesGeschaeftsjahr
	
	self initialisiereAnzeigeFuerAktuellesGeschaeftsjahr.
	self lehrveranstaltungenComponent items: self myAdmin menueDozenten! !

!DsEinsatzplanung methodsFor: 'fromVw' stamp: 'JohannesBrauer 3/16/2014 16:18'!
ausVw
	| exportDatei sws arr |
	exportDatei := StandardFileStream fileNamed: 'daten.sixx'.
	sws := nil.
	sws := exportDatei contents.
	exportDatei close.
	arr := Object readSixxFrom: sws.
	self myAdmin module: (arr first).
	self myAdmin studienrichtungen: (arr at: 2).
	self myAdmin manipel: (arr at: 3).
	self myAdmin quartalsplaene: (arr at: 4).
	self myAdmin dozenten: (arr at: 5).
	self class aktuellesGeschaeftsjahr: (arr at: 6).
	DmDozent nn: (self myAdmin dozenten select: [ :d | d name = 'NN' ]) first.
	self aktualisiereAnzeigeFuerAktuellesGeschaeftsjahr.
	self changedQuartal.
	self changedLehrveranstaltung! !

!DsEinsatzplanung methodsFor: 'change messages' stamp: ' 15/1/14 15:24'!
bestimmeNeuesQuartal: einQuartal
	"stellt fest, ob sich das Gesch√§ftsjahr geaendert hat"
	
	einQuartal geschaeftsjahreszahl = AktuellesGeschaeftsjahr
		ifTrue: [self quartal: einQuartal]
		ifFalse: [self quartal: self quartalsListe first]! !

!DsEinsatzplanung methodsFor: 'change messages' stamp: 'JohannesBrauer 3/17/2014 11:09'!
changedAltesGeschaeftsjahr
	AktuellesGeschaeftsjahr := self geschaeftsjahr.
	self initialisiereAnzeigeFuerAktuellesGeschaeftsjahr.
	self changedQuartal! !

!DsEinsatzplanung methodsFor: 'change messages' stamp: 'JohannesBrauer 3/17/2014 11:10'!
changedGeschaeftsjahr: anInteger
	self geschaeftsjahr ~= anInteger
		ifTrue: [ 
			self geschaeftsjahr: anInteger.
			(self myAdmin existiertGeschaeftsjahrSchon: self geschaeftsjahr)
				ifTrue: [ self changedAltesGeschaeftsjahr ]
				ifFalse: [ self changedNeuesGeschaeftsjahr ] ]
		ifFalse: [  ]! !

!DsEinsatzplanung methodsFor: 'change messages' stamp: ' 15/1/14 15:24'!
changedLehrveranstaltung
	
	self myAdmin berechneAuslastungenFuer: geschaeftsjahr.
	self dozentenStundenComponent rows: self myAdmin menueDozenten! !

!DsEinsatzplanung methodsFor: 'change messages' stamp: 'JohannesBrauer 3/17/2014 11:10'!
changedNeuesGeschaeftsjahr
	(self confirm: 'Geschäftstjahr gib es noch nicht!!!! Anlegen?')
		ifFalse: [ self geschaeftsjahr: AktuellesGeschaeftsjahr ]
		ifTrue: [ 
			AktuellesGeschaeftsjahr := self geschaeftsjahr.
			self myAdmin erzeugeGeschaeftsjahr: AktuellesGeschaeftsjahr.
			self initialisiereAnzeigeFuerAktuellesGeschaeftsjahr.
			self changedQuartal ]! !

!DsEinsatzplanung methodsFor: 'change messages' stamp: ' 15/1/14 15:24'!
changedQuartal
	
	self lehrveranstaltungenComponent
		rows: (self myAdmin lehrveranstaltungenIn: self quartal)! !

!DsEinsatzplanung methodsFor: 'hooks' stamp: 'JohannesBrauer 3/12/2014 22:23'!
children
	
	^children ifNil: [ children := Bag new ]
! !

!DsEinsatzplanung methodsFor: 'actions' stamp: ' 15/1/14 15:24'!
delete: aDozEinPlanLehrveranstaltung
	
	self myAdmin entferneLehrveranstaltung: aDozEinPlanLehrveranstaltung.
	self changedLehrveranstaltung! !

!DsEinsatzplanung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
dozentenComponent
	
	^dozentenComponent! !

!DsEinsatzplanung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
dozentenComponent: anObject
	
	dozentenComponent := anObject! !

!DsEinsatzplanung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
dozentenStundenComponent
	
	^dozentenStundenComponent! !

!DsEinsatzplanung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
dozentenStundenComponent: anObject
	
	dozentenStundenComponent := anObject! !

!DsEinsatzplanung methodsFor: 'lehrveranstaltungen' stamp: ' 15/1/14 15:24'!
doziStundenSpaltenDefintionen
	
	self dozentenStundenComponent
		columns:
			((OrderedCollection new)
				add:
						((WAReportColumn selector: #name title: 'Dozent')
								sortBlock: [:x :y | x <= y]);
				add: (WAReportColumn selector: #stundenInQ4 title: 'Q4');
				add: (WAReportColumn selector: #stundenInQ1 title: 'Q1');
				add: (WAReportColumn selector: #stundenInQ2 title: 'Q2');
				add: (WAReportColumn selector: #stundenInQ3 title: 'Q3');
				add: (WAReportColumn selector: #summe title: 'Summe');
				yourself)! !

!DsEinsatzplanung methodsFor: 'actions' stamp: ' 15/1/14 15:24'!
dupliziere: aDozEinPlanLehrveranstaltung
	
	self myAdmin dupliziereLehrveranstaltung: aDozEinPlanLehrveranstaltung.
	self changedLehrveranstaltung! !

!DsEinsatzplanung methodsFor: 'lehrveranstaltungen' stamp: ' 15/1/14 15:24'!
edit: eineLehrveranstaltung
	
	self
		lightbox:
			(DsLehrveranstaltungEditor
				for: eineLehrveranstaltung
				with: self myAdmin menueDozenten)! !

!DsEinsatzplanung methodsFor: 'actions' stamp: 'jb 4/3/2016 18:07'!
eliminiereGeschaeftsjahr
	self
		chooseFrom: self myAdmin alleGeschaeftsjahre
		default: AktuellesGeschaeftsjahr
		caption: 'Auswahl des zu löschenden Geschäftsjahrs:'
		onAnswer: [ :selection | 
			selection isNil | (selection = 1)
				ifTrue: [ 
					"tue nichts, dummy Geschaeftsjahr wird nicht entfernt"
					 ]
				ifFalse: [ 
					self myAdmin eliminiereGeschaeftsjahr: selection.
					self geschaeftsjahr: 1.
					AktuellesGeschaeftsjahr := 1.
					quartal := nil.
					self initialisiereAnzeigeFuerAktuellesGeschaeftsjahr.
					self changedQuartal ] ]! !

!DsEinsatzplanung methodsFor: 'actions' stamp: 'JohannesBrauer 6/18/2014 09:27'!
exportiereLehrveranstaltungen
	"erzeugt eine csv-Datei fuer die Lehrveranstaltungen eines Quartals"

	| dateiname exportStream daten |
	dateiname := 'lehrveranstaltungen-' , self quartal printString , '.csv'.
	exportStream := FileStream fileNamed:  dateiname.
	exportStream binary.
	[ (self myAdmin lehrveranstaltungenIn: self quartal) do: [ :lv | lv exportTo: exportStream ] ]
		ensure: [ 
			daten := exportStream contents.
			exportStream close ].
	self requestContext
		respond: [ :response | 
			response
				binary;
				contentType: nil;
				document: daten asString;
				attachmentWithFileName: dateiname].
	(FileSystem  disk workingDirectory  / dateiname) delete.! !

!DsEinsatzplanung methodsFor: 'actions' stamp: 'JohannesBrauer 6/17/2014 21:09'!
exportiereLehrveranstaltungenAlt
	"erzeugt eine csv-Datei fuer die Lehrveranstaltungen eines Quartals"

	| exportDatei exportStream |
	exportDatei := 'lehrveranstaltungen-' , self quartal printString , '.csv'.
	exportStream := StandardFileStream fileNamed: exportDatei.
	[ (self myAdmin lehrveranstaltungenIn: self quartal) do: [ :lv | lv exportTo: exportStream ] ]
		ensure: [ exportStream close ].! !

!DsEinsatzplanung methodsFor: 'actions' stamp: ' 15/1/14 15:24'!
fuegeLehrveranstaltungHinzu
	
	self
		lightbox:
			(DsModulAuswahl
				for: self quartal
				with: (self myAdmin moduleFuerQuartal: self quartal)
				and: self myAdmin)! !

!DsEinsatzplanung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
geschaeftsjahr
	
	^geschaeftsjahr! !

!DsEinsatzplanung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
geschaeftsjahr: anObject
	
	geschaeftsjahr := anObject! !

!DsEinsatzplanung methodsFor: 'initialization' stamp: ' 15/1/14 15:24'!
initialisiereAnzeigeFuerAktuellesGeschaeftsjahr
	
	self
		quartal:
			(self myAdmin quartaleImGeschaeftsjahr: AktuellesGeschaeftsjahr)
				asSortedCollection first.
	self
		quartalsListe:
			(self myAdmin quartaleImGeschaeftsjahr: AktuellesGeschaeftsjahr)
				asSortedCollection! !

!DsEinsatzplanung methodsFor: 'initialization' stamp: 'jb 8/7/2017 16:51'!
initialize
	"initialize our components"

	super initialize.
	self myAdmin: DmAdmin new.
	self geschaeftsjahr: AktuellesGeschaeftsjahr.
	self myAdmin erzeugeGeschaeftsjahr: AktuellesGeschaeftsjahr.
	self quartal: nil.
	self initialisiereAnzeigeFuerAktuellesGeschaeftsjahr.
	self initializeLvComponent.
	self initializeMenuComponent.
	self initializeDoziStundenComponent.
	self initializeSicherungComponent.
	self initializeLoginComponent! !

!DsEinsatzplanung methodsFor: 'initialization' stamp: 'JohannesBrauer 3/18/2014 16:07'!
initializeDozentenComponent
	self dozentenComponent: (DsDozentenpflege with: self myAdmin andHeading: 'Dozentenpflege').
	self children add: self dozentenComponent! !

!DsEinsatzplanung methodsFor: 'initialization' stamp: 'JohannesBrauer 3/18/2014 16:05'!
initializeDoziStundenComponent
	self
		dozentenStundenComponent: (DsListComponent withTableTitle: 'Dozentenauslastung');
		doziStundenSpaltenDefintionen.
	self dozentenStundenComponent
		rowColors: #(#lightblue #lightyellow);
		rowPeriod: 1.
	self children add: self dozentenStundenComponent! !

!DsEinsatzplanung methodsFor: 'initialization' stamp: 'jb 8/7/2017 20:29'!
initializeLoginComponent
	self loginComponent: (DsLoginComponent new).
	self loginComponent onAnswer: [ :user | user ifNotNil: [ :u | self session login: u ] ].
	self children add: self loginComponent.
	self standardbenutzerAnlegen! !

!DsEinsatzplanung methodsFor: 'initialization' stamp: 'JohannesBrauer 3/18/2014 16:03'!
initializeLvComponent
	self
		lehrveranstaltungenComponent: (DsListComponent withItems: self myAdmin dozenten andTableTitle: 'Lehrveranstaltungen');
		lvSpaltenDefintionen.
	self lehrveranstaltungenComponent
		rows: self myAdmin alleLehrveranstaltungen;
		rowColors: #(#lightblue #lightyellow);
		rowPeriod: 1.
	self children add: self lehrveranstaltungenComponent! !

!DsEinsatzplanung methodsFor: 'initialization' stamp: ' 15/1/14 15:24'!
initializeManipelComponent
	
	self
		manipelComponent:
			(DsManipelpflege
				with: self myAdmin
				andHeading: 'Manipelpflege')! !

!DsEinsatzplanung methodsFor: 'initialization' stamp: 'jb 4/5/2016 18:34'!
initializeMenuComponent
	self
		menuComponent:
			(DsMenuComponent new
				addEntry: 'Datensicherung' withAction: [ self sichern ];
				addEntry: 'fuege LV hinzu' withAction: [ self fuegeLehrveranstaltungHinzu ];
				addEntry: 'Plane Quartal' withAction: [ self plane ];
				addEntry: 'CSV-Export' withAction: [ self exportiereLehrveranstaltungen ];
				addEntry: 'Module' withAction: [ self pflegeModule ];
				addEntry: 'Dozenten' withAction: [ self pflegeDozenten ];
				addEntry: 'Manipel' withAction: [ self pflegeManipel ];
				addEntry: 'elim. G-Jahr' withAction: [ self eliminiereGeschaeftsjahr ];
				addEntry: 'neues G-Jahr' withAction: [ self neuesGeschaeftsjahr ];
				yourself).
	self children add: self menuComponent! !

!DsEinsatzplanung methodsFor: 'initialization' stamp: ' 15/1/14 15:24'!
initializeModuleComponent
	
	self
		moduleComponent:
			(DsModulpflege
				with: self myAdmin
				andHeading: 'Modulpflege')! !

!DsEinsatzplanung methodsFor: 'initialization' stamp: 'JohannesBrauer 2/8/2014 13:15'!
initializeSicherungComponent
	
	self
		sicherungComponent:
			(DsDatensicherung
				with: self myAdmin
				andHeading: 'Datensicherung')! !

!DsEinsatzplanung methodsFor: 'actions' stamp: 'JohannesBrauer 3/16/2014 16:18'!
laden
	| data |
	data := FLMaterializer materializeFromFileNamed: 'eplan.db'.
	self myAdmin: (data first). 
	self geschaeftsjahr: (data at: 2).
	self class aktuellesGeschaeftsjahr: self geschaeftsjahr .
	DmDozent nn: (self myAdmin dozenten select: [:d | d name = 'NN']) first.
	self aktualisiereAnzeigeFuerAktuellesGeschaeftsjahr.
	"self myAdmin definiereStandardbelegungen."
	self changedQuartal.
	self changedLehrveranstaltung! !

!DsEinsatzplanung methodsFor: 'actions' stamp: 'jb 4/5/2016 17:19'!
laden: data
	self myAdmin: (data first).
	self myAdmin legStudienrichtungAngInforAnFallsNichtExistiert.
	self geschaeftsjahr: (data at: 2).
	self class aktuellesGeschaeftsjahr: self geschaeftsjahr.
	DmDozent nn: (self myAdmin dozenten select: [ :d | d name = 'NN' ]) first.
	self aktualisiereAnzeigeFuerAktuellesGeschaeftsjahr.	"self myAdmin definiereStandardbelegungen."
	self changedQuartal.
	self changedLehrveranstaltung! !

!DsEinsatzplanung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
lehrveranstaltungen
	
	^lehrveranstaltungen! !

!DsEinsatzplanung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
lehrveranstaltungen: anObject
	
	lehrveranstaltungen := anObject! !

!DsEinsatzplanung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
lehrveranstaltungenComponent
	
	^lehrveranstaltungenComponent! !

!DsEinsatzplanung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
lehrveranstaltungenComponent: anObject
	
	lehrveranstaltungenComponent := anObject! !

!DsEinsatzplanung methodsFor: 'accessing' stamp: 'JohannesBrauer 3/15/2014 15:17'!
loginComponent
	^ loginComponent! !

!DsEinsatzplanung methodsFor: 'accessing' stamp: 'JohannesBrauer 3/15/2014 15:20'!
loginComponent: aDsLoginComponent 
	loginComponent := aDsLoginComponent! !

!DsEinsatzplanung methodsFor: 'private protocol' stamp: 'jb 8/7/2017 15:01'!
logout
    self session logout! !

!DsEinsatzplanung methodsFor: 'lehrveranstaltungen' stamp: 'JohannesBrauer 2/19/2014 19:23'!
lvSpaltenDefintionen
	
	self lehrveranstaltungenComponent
		columns:
			((OrderedCollection new)
				add:
						((WAReportColumn selector: #modul title: 'Modul')
								sortBlock: [:x :y | x modulName <= y modulName]);
				add:
						((WAReportColumn selector: #manipel title: 'Mnpl')
								sortBlock: [:x :y | x name <= y name]);
				add: (WAReportColumn selector: #semester title: 'Smstr');
				add: (WAReportColumn selector: #semesterWochenstunden title: 'SWS');
				add: (WAReportColumn selector: #wiederholungsFaktorGerundet title: 'WdhFkt');
				add: (WAReportColumn selector: #anzahlGruppen title: 'Grpn');
				add:
						((WAReportColumn
								selector: #dozent
								title: 'Dozent'
								onClick:
									[:lv | 
									self edit: lv.
									self changedLehrveranstaltung])
								sortBlock: [:x :y | x name <= y name]);
				add:
						((WAReportColumn new)
								title: 'Akt.';
								valueBlock: [:lv | 'entf'];
								clickBlock: [:lv | self delete: lv];
								sortBlock: nil;
								yourself);
				add:
						((WAReportColumn new)
								title: 'Akt.';
								valueBlock: [:lv | 'dupl'];
								clickBlock: [:lv | self dupliziere: lv];
								sortBlock: nil;
								yourself);
				yourself)! !

!DsEinsatzplanung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
manipelComponent
	
	^manipelComponent! !

!DsEinsatzplanung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
manipelComponent: anObject
	
	manipelComponent := anObject! !

!DsEinsatzplanung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
menuComponent
	
	^menuComponent! !

!DsEinsatzplanung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
menuComponent: anObject
	
	menuComponent := anObject! !

!DsEinsatzplanung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
moduleComponent
	
	^moduleComponent! !

!DsEinsatzplanung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
moduleComponent: aDozEinPlanModulpflegeSea
	
	moduleComponent := aDozEinPlanModulpflegeSea! !

!DsEinsatzplanung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
myAdmin
	
	^myAdmin! !

!DsEinsatzplanung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
myAdmin: anObject
	
	myAdmin := anObject! !

!DsEinsatzplanung methodsFor: 'actions' stamp: 'jb 4/6/2016 11:44'!
neuesGeschaeftsjahr
	| jahreszahl |
	jahreszahl := (self request: 'Geschäftsjahreszahl' label: 'erzeuge' default: '1') asUnsignedInteger.
	jahreszahl isNil
		ifTrue: [ self inform: 'Nur ganzzahlige Eingabe erlaubt' ]
		ifFalse: [ 
			(self myAdmin existiertGeschaeftsjahrSchon: jahreszahl)
				ifTrue: [ self inform: 'Geschäftjahr ' , jahreszahl printString , ' existiert bereits!!' ]
				ifFalse: [ 
					self geschaeftsjahr: jahreszahl.
					self myAdmin erzeugeGeschaeftsjahr: jahreszahl.
					self changedAltesGeschaeftsjahr ] ]! !

!DsEinsatzplanung methodsFor: 'actions' stamp: ' 15/1/14 15:24'!
pflegeDozenten
	""
	
	self initializeDozentenComponent.	"self dozentenComponent rows: self myAdmin dozenten."
	self call: self dozentenComponent.
	self changedLehrveranstaltung! !

!DsEinsatzplanung methodsFor: 'actions' stamp: ' 15/1/14 15:24'!
pflegeManipel
	""
	
	self initializeManipelComponent.
	self call: self manipelComponent! !

!DsEinsatzplanung methodsFor: 'actions' stamp: ' 15/1/14 15:24'!
pflegeModule
	""
	
	self initializeModuleComponent.
	self call: self moduleComponent.
	self changedLehrveranstaltung! !

!DsEinsatzplanung methodsFor: 'actions' stamp: 'JohannesBrauer 6/24/2014 16:14'!
plane
	"loest Planung fuer ausgewaehltes Quartal aus"

	(self confirm: 'Soll das Quartal wirklich neu geplant werden?')
		ifTrue: [ 
			self myAdmin erzeugeLehrveranstaltungenFuerQuartal: self quartal.
			self
				changedQuartal;
				changedLehrveranstaltung ]! !

!DsEinsatzplanung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
quartal
	
	^quartal! !

!DsEinsatzplanung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
quartal: anObject
	
	quartal := anObject! !

!DsEinsatzplanung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
quartalsListe
	
	^quartalsListe! !

!DsEinsatzplanung methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
quartalsListe: anObject
	
	quartalsListe := anObject! !

!DsEinsatzplanung methodsFor: 'rendering' stamp: 'jb 8/7/2017 20:40'!
renderContentOn: html
	(html heading)
		level: 2;
		with: 'Dozenten-Einsatzplanung'.
	html div
		id: '';
		with: [ 
					self session isLoggedIn 
						ifFalse: [ html render: loginComponent  ]
						ifTrue: [ 
							self renderHeaderOn: html.
							html horizontalRule.
							self renderLehrveranstaltungenComponent: html.
							self renderDozentenStundenComponent: html.
							self renderMenuComponent: html ] ].
	html anchor
    callback: [ self show: (WAInspector current on: self session) ];
    with: 'Inspect Session'! !

!DsEinsatzplanung methodsFor: 'rendering' stamp: 'JohannesBrauer 3/16/2014 15:15'!
renderDozentenStundenComponent: html
	
	(html div)
		class: 'doziStundenList';
		id: 'doziStundenListid';
		with: self dozentenStundenComponent! !

!DsEinsatzplanung methodsFor: 'rendering' stamp: 'jb 4/3/2016 00:20'!
renderGeschaeftsjahrOn: html
	
	html label: 'Geschäftsjahr'. html space.
	html select
				list: self myAdmin alleGeschaeftsjahre; 
				selected: self geschaeftsjahr;
				callback: [:value | self changedGeschaeftsjahr: value asNumber ]! !

!DsEinsatzplanung methodsFor: 'rendering' stamp: 'jb 4/3/2016 18:13'!
renderHeaderOn: html
	html
		form: [ 
			html
				div: [ 
					html space.
					self renderGeschaeftsjahrOn: html.
					html space.
					self renderQuartalOn: html.
					html submitButton ] ]! !

!DsEinsatzplanung methodsFor: 'rendering' stamp: 'JohannesBrauer 3/16/2014 15:16'!
renderLehrveranstaltungenComponent: html
	
	(html div)
		class: 'lvenList';
		id: 'lvenListid';
		with: self lehrveranstaltungenComponent! !

!DsEinsatzplanung methodsFor: 'rendering' stamp: ' 15/1/14 15:24'!
renderMenuComponent: html
	
	(html div)
		class: 'menu';
		id: 'menuid';
		with: self menuComponent! !

!DsEinsatzplanung methodsFor: 'rendering' stamp: 'jb 4/2/2016 20:28'!
renderQuartalOn: html
	html label: 'Quartal'.
	html space.
	html select
		list: self quartalsListe;
		selected: self quartal;
		callback: [ :value | 
					self bestimmeNeuesQuartal: value.
					self changedQuartal ]! !

!DsEinsatzplanung methodsFor: 'private' stamp: 'JohannesBrauer 3/16/2014 16:15'!
schreibe: lv in: aStream
	aStream
		cr;
		nextPutAll: lv modul modulName;
		nextPutAll: (String with: Character tab);
		nextPutAll: (lv modul semesterWochenstunden at: (lv manipel semesterInQuartal: self quartal value)) printString;
		nextPutAll: (String with: Character tab).
	lv wiederholungsFaktor = 1
		ifFalse: [ aStream nextPutAll: lv wiederholungsFaktor printString ]! !

!DsEinsatzplanung methodsFor: 'private' stamp: 'JohannesBrauer 3/16/2014 16:15'!
schreibe: name mal: n in: aStream
	n
		timesRepeat: [ 
			aStream
				nextPutAll: (String with: Character tab);
				nextPutAll: name ]! !

!DsEinsatzplanung methodsFor: 'private' stamp: ' 15/1/14 15:24'!
schreibeLvenIn: exportStream FuerManipel: mpl
	
	| grppn letzelv |
	self schreibeUeberschriftIn: exportStream Fuer: mpl.
	grppn := 0.
	letzelv := DmLehrveranstaltung new modul: DmModul new.
	(self myAdmin lehrveranstaltungenIn: self quartal value)
		do:
			[:lv | 
			lv manipel = mpl
				ifTrue:
					[grppn = 0 | (letzelv modul modulName ~= lv modul modulName)
						| ((lv modul modulName copyFrom: 1 to: 4) = 'Fach')
						ifTrue: [self schreibe: lv in: exportStream].
					self
						schreibe: lv dozent name
						mal: lv anzahlGruppen
						in: exportStream.
					grppn := grppn + lv anzahlGruppen.
					grppn = lv manipel anzahlGruppen ifTrue: [grppn := 0].
					letzelv := lv]].
	exportStream cr! !

!DsEinsatzplanung methodsFor: 'private' stamp: 'JohannesBrauer 3/16/2014 16:15'!
schreibeUeberschriftIn: exportStream Fuer: mpl
	| tabAsString |
	tabAsString := String with: Character tab.
	exportStream
		cr;
		nextPutAll: (mpl semesterInQuartal: self quartal value) printString;
		nextPutAll: '. Semester Studiengang ';
		nextPutAll: mpl studienrichtung name;
		nextPutAll: ' ';
		nextPutAll: mpl studienrichtung abschluss;
		cr;
		nextPutAll: 'Fach';
		nextPutAll: tabAsString;
		nextPutAll: 'St';
		nextPutAll: tabAsString;
		nextPutAll: 'Fkt'.
	1 to: mpl anzahlGruppen do: [ :i | 
		exportStream
			nextPutAll: tabAsString;
			nextPutAll: 'Gruppe ';
			nextPutAll: i printString ].
	exportStream
		nextPutAll: tabAsString;
		nextPutAll: ' Raum '! !

!DsEinsatzplanung methodsFor: 'actions' stamp: 'JohannesBrauer 2/8/2014 20:20'!
sichern
	| data |
	self initializeSicherungComponent.
	data := (self call: self sicherungComponent).
	data isNil ifFalse: [self laden: data]! !

!DsEinsatzplanung methodsFor: 'accessing' stamp: 'JohannesBrauer 2/8/2014 13:18'!
sicherungComponent
	
	^sicherungComponent! !

!DsEinsatzplanung methodsFor: 'accessing' stamp: 'JohannesBrauer 2/8/2014 13:19'!
sicherungComponent: aComponent
	
	sicherungComponent := aComponent! !

!DsEinsatzplanung methodsFor: 'actions' stamp: ' 15/1/14 15:24'!
standardBelegung
	"l√∂st Planung f√ºr ausgew√§hltes Quartal aus"
	
	self myAdmin erzeugeStandardBelegungFuerQuartal: self quartal.
	self
		changedQuartal;
		changedLehrveranstaltung! !

!DsEinsatzplanung methodsFor: 'benutzer' stamp: 'jb 8/7/2017 20:12'!
standardbenutzerAnlegen

self loginComponent addUser: 'jb' withPassword: 'fbplaner' .
self loginComponent addUser: 'hs' withPassword: 'wiplaner' .
self loginComponent addUser: 'js' withPassword: 'aiplaner' .
! !

!DsEinsatzplanung methodsFor: 'updating' stamp: 'JohannesBrauer 3/16/2014 15:16'!
updateRoot: anHtmlRoot
	
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'Dozenten-Einsatzplanung'.
	(anHtmlRoot link)
		type: 'text/css';
		beStylesheet;
		addAll;
		url: DsFileLibrary / 'doziplan.css'! !

WAComponent subclass: #DsItemEditor
	instanceVariableNames: 'item'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DozEinPlan'!

DsItemEditor subclass: #DsDateiEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DozEinPlan'!

!DsDateiEditor methodsFor: 'accessing' stamp: 'JohannesBrauer 3/3/2014 10:12'!
dateiname
	^self item basename! !

!DsDateiEditor methodsFor: 'accessing' stamp: 'JohannesBrauer 3/3/2014 11:15'!
dateiname: aString
	| dir |
	dir := self item parent.
	(dir / aString) exists
		ifFalse: [ ^ self item renameTo: aString ]
		ifTrue: [ self inform: 'Datei mit diesem Namen existiert bereits.' ]! !

!DsDateiEditor methodsFor: 'rendering' stamp: 'JohannesBrauer 3/6/2014 22:27'!
renderContentOn: html
	html
		div: [ 
			html text: 'Datei umbenennen: '. html break.
			html form
				class: 'eventEditor';
				with: [ 
							self
								renderDateinameOn: html;
								renderButtonsOn: html;
								yourself ] ]! !

!DsDateiEditor methodsFor: 'rendering' stamp: 'JohannesBrauer 3/3/2014 10:10'!
renderDateinameOn: canvas
	
	| tagID |
	canvas
		div:
			[(canvas label)
				for: (tagID := canvas nextId);
				with: 'Dateiname: '.
			canvas textInput
				on: #dateiname
				of: self]! !

DsItemEditor subclass: #DsDozentEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DozEinPlan'!

!DsDozentEditor methodsFor: 'rendering' stamp: ' 15/1/14 15:24'!
renderContentOn: html
	
	html
		div:
			[(html form)
				class: 'eventEditor';
				id: 'dzEditor';
				with:
						[self
								renderNameOn: html;
								renderVornameOn: html;
								renderInsMenueOn: html;
								renderSollstundenOn: html;
								renderButtonsOn: html;
								yourself]]! !

!DsDozentEditor methodsFor: 'rendering' stamp: 'jb 1/25/2014 23:30'!
renderInsMenueOn: canvas
	
	| tagID |
	canvas
		div:
			[(canvas label)
				for: (tagID := canvas nextId);
				with: 'ins Menü'.
			((canvas select)
				add: true;
				add: false;
				on: #insMenue
					of: self item;
				labels:
						[:value | 
							value
								ifTrue: ['ja']
								ifFalse: ['nein']];
				yourself) id: tagID]! !

!DsDozentEditor methodsFor: 'rendering' stamp: ' 15/1/14 15:24'!
renderSollstundenOn: canvas
	
	| tagID |
	canvas
		div:
			[(canvas label)
				for: (tagID := canvas nextId);
				with: 'Sollstunden: '.
			(canvas textInput
				on: #sollStunden
				of: self item) id: tagID]! !

!DsDozentEditor methodsFor: 'rendering' stamp: ' 15/1/14 15:24'!
renderVornameOn: canvas
	
	| tagID |
	canvas
		div:
			[(canvas label)
				for: (tagID := canvas nextId);
				with: 'Vorname: '.
			canvas textInput
				on: #vorname
				of: self item]! !

!DsItemEditor class methodsFor: 'instance creation' stamp: ' 15/1/14 15:24'!
for: anItem
	
	^(self new)
		item: anItem;
		yourself! !

!DsItemEditor class methodsFor: 'instance creation' stamp: 'jb 4/5/2016 17:39'!
for: aDmManipel with: aCollection 
	^(self for: aDmManipel) selectList: aCollection! !

!DsItemEditor methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
item
	
	^item! !

!DsItemEditor methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
item: anItem
	
	item := anItem! !

!DsItemEditor methodsFor: 'rendering' stamp: ' 15/1/14 15:24'!
renderButtonsOn: canvas
	
	canvas
		div:
			[canvas
				span:
					[(canvas cancelButton)
						callback: [self answer: false];
						value: 'Abbrechen'].
			canvas
				span:
					[(canvas submitButton)
						callback: [self answer: true];
						value: 'Speichern']]! !

!DsItemEditor methodsFor: 'rendering' stamp: ' 15/1/14 15:24'!
renderInstVar: instVar on: canvas
	
	| tagID |
	canvas
		div:
			[(canvas label)
				for: (tagID := canvas nextId);
				with: instVar capitalized.
			(canvas textInput
				on: instVar asSymbol
				of: self item) id: tagID]! !

!DsItemEditor methodsFor: 'rendering' stamp: ' 15/1/14 15:24'!
renderNameOn: canvas
	
	| tagID |
	canvas
		div:
			[(canvas label)
				for: (tagID := canvas nextId);
				with: 'Name: '.
			(canvas textInput
				on: #name
				of: self item) id: tagID]! !

!DsItemEditor methodsFor: 'rendering' stamp: ' 15/1/14 15:24'!
renderSemesterOn: canvas
	
	| tagID |
	1
		to: 7
		do:
			[:sem | 
			canvas
				div:
					[(canvas label)
						for: (tagID := canvas nextId);
						with: sem printString , '. Semester'.
					(canvas textInput
						on: ('semester' , sem printString) asSymbol
						of: self item) id: tagID]]! !

!DsItemEditor methodsFor: 'updating' stamp: 'JohannesBrauer 3/16/2014 15:16'!
updateRoot: anHtmlRoot
	
	super updateRoot: anHtmlRoot.
	(anHtmlRoot link)
		type: 'text/css';
		beStylesheet;
		addAll;
		url: DsFileLibrary / 'doziplan.css'! !

DsItemEditor subclass: #DsStudienrichtungsAbhaengerEditor
	instanceVariableNames: 'selectList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DozEinPlan'!

DsStudienrichtungsAbhaengerEditor subclass: #DsManipelEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DozEinPlan'!

!DsManipelEditor methodsFor: 'rendering' stamp: 'jb 4/5/2016 16:01'!
renderContentOn: html
	html
		div: [ 
			html form
				class: 'eventEditor';
				id: 'moEditor';
				with: [ 
							self renderInstVar: 'name' on: html.
							self renderStudienrichtungOn: html.
							self renderInstVar: 'anzahlGruppen' on: html.
							self renderStudienbeginnOn: html.
							self renderSemesterOn: html.
							self
								renderButtonsOn: html;
								yourself ] ]! !

!DsManipelEditor methodsFor: 'rendering' stamp: ' 15/1/14 15:24'!
renderStudienbeginnOn: canvas
	
	| tagID |
	canvas
		div:
			[(canvas label)
				for: (tagID := canvas nextId);
				with: 'Studienbeginn: '.
			(canvas textInput
				on: #studienbeginnSea
				of: self item) id: tagID]! !

DsStudienrichtungsAbhaengerEditor subclass: #DsModulEditor
	instanceVariableNames: 'selectList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DozEinPlan'!

!DsModulEditor methodsFor: 'rendering' stamp: ' 15/1/14 15:24'!
renderAbBisOn: html
	
	| tagID |
	html
		div:
			[(html label)
				for: (tagID := html nextId);
				with: 'ab Studienbeginn'.
			(html textInput
				on: #ab
				of: self item) id: tagID.
			(html label)
				for: (tagID := html nextId);
				with: 'bis Studienbeginn'.
			(html textInput
				on: #bis
				of: self item) id: tagID]! !

!DsModulEditor methodsFor: 'rendering' stamp: 'jb 4/5/2016 17:57'!
renderContentOn: html
	html
		div: [ 
			html form
				class: 'eventEditor';
				id: 'maEditor';
				with: [ 
							self renderInstVar: 'modulNummer' on: html.
							self renderInstVar: 'modulName' on: html.
							self renderStudienrichtungOn: html.
							self renderSemesterOn: html.
							self renderAbBisOn: html.
							self
								renderButtonsOn: html;
								yourself ] ]! !

!DsStudienrichtungsAbhaengerEditor methodsFor: 'rendering' stamp: 'jb 4/5/2016 17:51'!
renderStudienrichtungOn: canvas
	
	| tagID |
	canvas
		div:
			[(canvas label)
				for: (tagID := canvas nextId);
				with: 'Studienrichtung: '.
			(canvas select)
				list: self selectList;
				on: #studienrichtung
					of: self item;
				labels: [:each | each name,'-', each abschluss ];
				callback: [:stdnrchtng | self item studienrichtung: stdnrchtng ]]! !

!DsStudienrichtungsAbhaengerEditor methodsFor: 'accessing' stamp: 'jb 4/5/2016 17:55'!
selectList
	^ selectList ! !

!DsStudienrichtungsAbhaengerEditor methodsFor: 'accessing' stamp: 'jb 4/5/2016 17:55'!
selectList: aCollection
 selectList := aCollection
	! !

WAComponent subclass: #DsJahresuebersichtComponent
	instanceVariableNames: 'geschaeftsjahr lehrveranstaltungen'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DozEinPlan'!

!DsJahresuebersichtComponent methodsFor: 'accessing' stamp: 'JohannesBrauer 2/23/2014 17:43'!
geschaeftsjahr
	
	^ geschaeftsjahr! !

!DsJahresuebersichtComponent methodsFor: 'accessing' stamp: 'JohannesBrauer 2/23/2014 17:29'!
geschaeftsjahr: aSmallInteger 
	geschaeftsjahr := aSmallInteger! !

!DsJahresuebersichtComponent methodsFor: 'accessing' stamp: 'JohannesBrauer 2/23/2014 17:46'!
lehrveranstaltungen
	^ lehrveranstaltungen! !

!DsJahresuebersichtComponent methodsFor: 'accessing' stamp: 'JohannesBrauer 2/23/2014 17:28'!
lehrveranstaltungen: anOrderedCollection 
	lehrveranstaltungen := anOrderedCollection! !

!DsJahresuebersichtComponent methodsFor: 'rendering' stamp: 'JohannesBrauer 2/23/2014 18:57'!
renderContentOn: html
	| s4 s3 s2 s1 |
	html heading
		level: 3;
		with: 'Jahresübersicht'.
	html
		table: [ 
			html
				tableRow: [ 
					html tableHeading: 'Quartal'.
					html tableHeading: 'Stunden' ].
			html
				tableRow: [ 
					html tableData: 'Q4'.
					html tableData: (s4 := (self stundenInQuartal: (DmQuartal jahr: self geschaeftsjahr - 1 nr: 4)) asFloat round: 1) ].
			html
				tableRow: [ 
					html tableData: 'Q1'.
					html tableData: (s1 := (self stundenInQuartal: (DmQuartal jahr: self geschaeftsjahr nr: 1)) asFloat round: 1) ].
			html
				tableRow: [ 
					html tableData: 'Q2'.
					html tableData: (s2 := (self stundenInQuartal: (DmQuartal jahr: self geschaeftsjahr nr: 2)) asFloat round: 1) ].
			html
				tableRow: [ 
					html tableData: 'Q3'.
					html tableData: (s3 := (self stundenInQuartal: (DmQuartal jahr: self geschaeftsjahr nr: 3)) asFloat round: 1) ].
			html
				tableRow: [ 
					html tableData: 'Summe'.
					html tableData: s4 + s3 + s2 + s1 ] ]! !

!DsJahresuebersichtComponent methodsFor: 'accessing' stamp: 'jb 4/1/2016 19:24'!
stundenInQuartal: aDmQuartal 
	| sum |
	sum := 0.
	self lehrveranstaltungen do:  [ :lv | lv quartal = aDmQuartal ifTrue: [ sum := sum + lv lvStunden  ] ].
	^sum! !

WAComponent subclass: #DsLehrveranstaltungEditor
	instanceVariableNames: 'lehrveranstaltung dozenten'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DozEinPlan'!

!DsLehrveranstaltungEditor class methodsFor: 'instance creation' stamp: ' 15/1/14 15:24'!
for: aDozEinPlanLehrveranstaltung with: aSortedCollection
	
	^(self new)
		lehrveranstaltung: aDozEinPlanLehrveranstaltung;
		dozenten: aSortedCollection;
		yourself! !

!DsLehrveranstaltungEditor methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
dozenten
	
	^dozenten! !

!DsLehrveranstaltungEditor methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
dozenten: aSortedCollection
	
	dozenten := aSortedCollection! !

!DsLehrveranstaltungEditor methodsFor: 'rendering' stamp: 'jb 4/5/2016 14:47'!
enderManipelOnn: canvas
	
	| tagID |
	canvas
		div:
			[(canvas label)
				for: (tagID := canvas nextId);
				with: 'Manipel: '.
			(canvas label)
				id: tagID;
				with: self lehrveranstaltung manipel]! !

!DsLehrveranstaltungEditor methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
lehrveranstaltung
	
	^lehrveranstaltung! !

!DsLehrveranstaltungEditor methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
lehrveranstaltung: aDozEinPlanLehrveranstaltung
	
	lehrveranstaltung := aDozEinPlanLehrveranstaltung! !

!DsLehrveranstaltungEditor methodsFor: 'rendering' stamp: ' 15/1/14 15:24'!
renderButtonsOn: canvas
	
	canvas
		div:
			[canvas
				span:
					[(canvas cancelButton)
						callback: [self answer: false];
						value: 'Abbrechen'].
			canvas
				span:
					[(canvas submitButton)
						callback: [self answer: true];
						value: 'Speichern']]! !

!DsLehrveranstaltungEditor methodsFor: 'rendering' stamp: ' 15/1/14 15:24'!
renderContentOn: html
	
	html
		div:
			[(html form)
				class: 'eventEditor';
				id: 'lvEditor';
				with:
						[self
								renderModulOn: html;
								renderManipelOn: html;
								renderSemesterOn: html;
								renderStundenOn: html;
								renderWiederholungsfaktorOn: html;
								renderGruppenOn: html;
								renderDozentOn: html;
								renderButtonsOn: html;
								yourself]]! !

!DsLehrveranstaltungEditor methodsFor: 'rendering' stamp: ' 15/1/14 15:24'!
renderDozentOn: canvas
	
	| tagID |
	canvas
		div:
			[(canvas label)
				for: (tagID := canvas nextId);
				with: 'Dozent '.
			(canvas select)
				list: self dozenten;
				on: #dozent
					of: self lehrveranstaltung;
				labels: [:each | each name];
				callback: [:dozent | self lehrveranstaltung dozent: dozent]]! !

!DsLehrveranstaltungEditor methodsFor: 'rendering' stamp: ' 15/1/14 15:24'!
renderGruppenOn: canvas
	
	| tagID |
	canvas
		div:
			[(canvas label)
				for: (tagID := canvas nextId);
				with: 'Gruppen: '.
			(canvas textInput
				on: #anzahlGruppen
				of: self lehrveranstaltung) id: tagID]! !

!DsLehrveranstaltungEditor methodsFor: 'rendering' stamp: 'jb 4/5/2016 14:51'!
renderManipelOn: canvas
	
	| tagID |
	canvas
		div:
			[(canvas label)
				for: (tagID := canvas nextId);
				with: 'Manipel: '.
			(canvas label)
				id: tagID;
				with: self lehrveranstaltung manipel]! !

!DsLehrveranstaltungEditor methodsFor: 'rendering' stamp: 'JohannesBrauer 3/16/2014 15:31'!
renderModulOn: canvas
	
	canvas
		div:
			[canvas label with: 'Modul: '.	"				for: (tagID := canvas nextId);"
			canvas label with: self lehrveranstaltung modul	"id: tagID;"]! !

!DsLehrveranstaltungEditor methodsFor: 'rendering' stamp: ' 15/1/14 15:24'!
renderSemesterOn: canvas
	
	| tagID |
	canvas
		div:
			[(canvas label)
				for: (tagID := canvas nextId);
				with: 'Semester: '.
			canvas text: self lehrveranstaltung semester]! !

!DsLehrveranstaltungEditor methodsFor: 'rendering' stamp: ' 15/1/14 15:24'!
renderStundenOn: canvas
	
	| tagID |
	canvas
		div:
			[(canvas label)
				for: (tagID := canvas nextId);
				with: 'SWS: '.
			canvas text: self lehrveranstaltung semesterWochenstunden]! !

!DsLehrveranstaltungEditor methodsFor: 'rendering' stamp: ' 15/1/14 15:24'!
renderWiederholungsfaktorOn: canvas
	
	| tagID |
	canvas
		div:
			[(canvas label)
				for: (tagID := canvas nextId);
				with: 'Wiederholungsfaktor: '.
			(canvas textInput
				on: #wiederholungsFaktor
				of: self lehrveranstaltung) id: tagID]! !

!DsLehrveranstaltungEditor methodsFor: 'updating' stamp: 'JohannesBrauer 3/16/2014 15:16'!
updateRoot: anHtmlRoot
	
	super updateRoot: anHtmlRoot.
	(anHtmlRoot link)
		type: 'text/css';
		beStylesheet;
		addAll;
		url: DsFileLibrary / 'doziplan.css'! !

WAComponent subclass: #DsLoginComponent
	instanceVariableNames: 'users username password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DozEinPlan'!

!DsLoginComponent methodsFor: 'user' stamp: 'jb 8/7/2017 16:58'!
addUser: aString withPassword: aString2 
	self users at: aString put: aString2 .! !

!DsLoginComponent methodsFor: 'rendering' stamp: 'jb 8/7/2017 17:23'!
initialize
	super initialize .
	users := Dictionary new.! !

!DsLoginComponent methodsFor: 'user' stamp: 'jb 8/7/2017 20:08'!
login
	((self users includesKey: username) and: [ (self users at: username) = password ])
		ifTrue: [ self answer: username ]
		ifFalse: [ self inform: 'Benutzername und/oder Passwort sind falsch!!' ]! !

!DsLoginComponent methodsFor: 'rendering' stamp: 'jb 8/7/2017 17:29'!
renderButtonRows: html
	html
		tableRow: [ html tableData.
			html
				tableData: [ html button
						callback: [ self login ];
						with: 'Login' ] ]! !

!DsLoginComponent methodsFor: 'rendering' stamp: 'jb 8/7/2017 19:52'!
renderContentOn: html
	html form: [self renderLoginFormContent: html]! !

!DsLoginComponent methodsFor: 'rendering' stamp: 'JohannesBrauer 3/14/2014 21:04'!
renderLoginFormContent: html

	html table: [
		self renderUsernameRow: html.
		self renderPasswordRow: html.
		self renderButtonRows: html]! !

!DsLoginComponent methodsFor: 'rendering' stamp: 'jb 8/7/2017 17:22'!
renderPasswordRow: html

	html
		tableRow: [ html tableData: [ html label: 'Passwort ' ].
			html tableData: [ html passwordInput callback: [ :v | password := v ] ] ]! !

!DsLoginComponent methodsFor: 'rendering' stamp: 'jb 8/7/2017 17:20'!
renderUsernameRow: html
	html
		tableRow: [ html tableData: [ html label: 'Benutzername: ' ].
			html tableData: [ html textInput callback: [ :v | username := v ] ] ]! !

!DsLoginComponent methodsFor: 'accessing' stamp: 'jb 8/7/2017 17:00'!
users
	^ users! !

WAComponent subclass: #DsMenuComponent
	instanceVariableNames: 'entries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DozEinPlan'!

!DsMenuComponent methodsFor: 'initialization' stamp: ' 15/1/14 15:24'!
addEntry: aString withAction: aBlock
	
	self entries add: aString -> aBlock! !

!DsMenuComponent methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
entries
	
	^entries! !

!DsMenuComponent methodsFor: 'initialization' stamp: ' 15/1/14 15:24'!
initialize
	
	super initialize.
	entries := OrderedCollection new! !

!DsMenuComponent methodsFor: 'rendering' stamp: 'jb 1/15/2014 20:02'!
renderContentOn: html
	
	(html heading)
		level: 3;
		with: 'Menü'.
	self entries
		do:
			[:entry | 
			(html anchor)
				callback: entry value;
				with: entry key]
		separatedBy: [html break]! !

WAComponent subclass: #DsMessageComponent
	instanceVariableNames: 'message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DozEinPlan'!

!DsMessageComponent class methodsFor: 'instance creation' stamp: ' 15/1/14 15:24'!
warn: einText
	
	^self new message: einText! !

!DsMessageComponent methodsFor: 'initialization' stamp: ' 15/1/14 15:24'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.	" *** Replace this comment with the appropriate initialization code *** "
	^self! !

!DsMessageComponent methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
message
	
	^message! !

!DsMessageComponent methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
message: anObject
	
	message := anObject! !

!DsMessageComponent methodsFor: 'rendering' stamp: ' 15/1/14 15:24'!
renderContentOn: html
	
	html
		div:
			[(html form)
				class: 'message';
				id: 'manipelMessage';
				with:
						[(html heading)
								level: 3;
								with: self message.
							(html submitButton)
								callback: [self answer: true];
								value: 'Ok']]! !

!DsMessageComponent methodsFor: 'updating' stamp: 'JohannesBrauer 3/16/2014 15:16'!
updateRoot: anHtmlRoot
	
	super updateRoot: anHtmlRoot.
	(anHtmlRoot link)
		type: 'text/css';
		beStylesheet;
		addAll;
		url: DsFileLibrary / 'doziplan.css'! !

WAComponent subclass: #DsModulAuswahl
	instanceVariableNames: 'quartal module admin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DozEinPlan'!

!DsModulAuswahl class methodsFor: 'instance creation' stamp: 'JohannesBrauer 3/16/2014 15:35'!
for: aDozEinPlanQuartal with: aSortedCollection
	
	^(self new)
		quartal: aDozEinPlanQuartal;
		module: aSortedCollection;yourself! !

!DsModulAuswahl class methodsFor: 'instance creation' stamp: 'JohannesBrauer 3/16/2014 15:35'!
for: aDozEinPlanQuartal with: aSortedCollection and: anAdmin
	
	^(self new)
		quartal: aDozEinPlanQuartal;
		module: aSortedCollection;
		admin: anAdmin; yourself! !

!DsModulAuswahl methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
admin
	
	^admin! !

!DsModulAuswahl methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
admin: anDozEinPlanAdmin
	
	admin := anDozEinPlanAdmin! !

!DsModulAuswahl methodsFor: 'initialization' stamp: ' 15/1/14 15:24'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.	" *** Replace this comment with the appropriate initialization code *** "
	^self! !

!DsModulAuswahl methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
module
	
	^module! !

!DsModulAuswahl methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
module: anObject
	
	module := anObject! !

!DsModulAuswahl methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
quartal
	
	^quartal! !

!DsModulAuswahl methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
quartal: aDozEinPlanQuartal
	
	quartal := aDozEinPlanQuartal! !

!DsModulAuswahl methodsFor: 'rendering' stamp: 'jb 4/3/2016 19:28'!
renderButtonsOn: canvas
	
	canvas
		div:
			[canvas
				span:
					[(canvas cancelButton)
						callback: [self answer: false];
						value: 'Abbrechen'].
			canvas
				span:
					[(canvas submitButton)
						callback: [self answer: true];
						value: 'übernehmen']]! !

!DsModulAuswahl methodsFor: 'rendering' stamp: ' 15/1/14 15:24'!
renderContentOn: html
	
	html
		div:
			[(html form)
				class: 'modulAuswahl';
				id: 'module';
				with:
						["html text: 'Modulauswahl'."
							self
								renderModuleOn: html;
								renderButtonsOn: html;
								yourself]]! !

!DsModulAuswahl methodsFor: 'rendering' stamp: ' 15/1/14 15:24'!
renderModuleOn: canvas
	
	canvas
		div:
			[canvas label with: 'Modul: '.
			(canvas select)
				list: self module;
				labels: [:each | each printString];
				callback:
						[:modul | 
							self admin
								erzeugeLehrveranstaltungenFuerModul: modul
								inQuartal: self quartal]]! !

!DsModulAuswahl methodsFor: 'updating' stamp: 'JohannesBrauer 3/16/2014 15:17'!
updateRoot: anHtmlRoot
	
	super updateRoot: anHtmlRoot.
	(anHtmlRoot link)
		type: 'text/css';
		beStylesheet;
		addAll;
		url: DsFileLibrary / 'doziplan.css'! !

WATableReport subclass: #DsListComponent
	instanceVariableNames: 'myChildren items tableTitle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DozEinPlan'!

!DsListComponent class methodsFor: 'instance creation' stamp: ' 15/1/14 15:24'!
withItems: aSortedCollection andTableTitle: aString
	"erzeugt eine WATableReport-Componente mit  Dozentenliste aSortedCollection 
         und Tabellentitel aString"
	
	^self basicNew withItems: aSortedCollection andTableTitle: aString! !

!DsListComponent class methodsFor: 'instance creation' stamp: ' 15/1/14 15:24'!
withTableTitle: aString
	"erzeugt eine WATableReport-Componente mit  Dozentenliste aSortedCollection 
         und Tabellentitel aString"
	
	^self basicNew
		withItems: OrderedCollection new
		andTableTitle: aString! !

!DsListComponent methodsFor: 'hooks' stamp: ' 15/1/14 15:24'!
children
	
	^myChildren! !

!DsListComponent methodsFor: 'initialization' stamp: ' 15/1/14 15:24'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.
	myChildren := OrderedCollection new! !

!DsListComponent methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
items
	
	^items! !

!DsListComponent methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
items: anObject
	
	items := anObject! !

!DsListComponent methodsFor: 'rendering' stamp: ' 15/1/14 15:24'!
renderContentOn: html
	
	(html heading)
		level: 3;
		with: self tableTitle.
	super renderContentOn: html! !

!DsListComponent methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
tableTitle
	
	^tableTitle! !

!DsListComponent methodsFor: 'accessing' stamp: ' 15/1/14 15:24'!
tableTitle: anObject
	
	tableTitle := anObject! !

!DsListComponent methodsFor: 'initialization' stamp: ' 15/1/14 15:24'!
withItems: aSortedCollection andTableTitle: aString
	
	self
		items: aSortedCollection;
		tableTitle: aString;
		initialize! !

DsEinsatz initialize!

DsEinsatzplanung initialize!
